﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\..\INSTALL - USB Recycle Bin.exe
Created_Date=1
Execution_Level=4
[VERSION]
Set_Version_Info=1
Company_Name=Nico.Godvician – GNU-GPL-2
File_Description=INSTALL - USB Recycle Bin
File_Version=1.0.3.52
Inc_File_Version=1
Internal_Name=INSTALL - USB Recycle Bin.ahk
Legal_Copyright=GNU-GPL-2 – Nico.Godvician
Original_Filename=INSTALL - USB Recycle Bin.exe
Product_Name=USB Recycle Bin
Product_Version=1.0.2020.1
[ICONS]
Icon_1=%In_Dir%\Ressources\Ico-Trash-Blue.ico

* * * Compile_AHK SETTINGS END * * *
*/

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

FileEncoding  % "UTF-16" ; Encoding all Text File created in Unicode



;**************************
;
; INSTALL USB Recycle Bin
;
;**************************



; CONSTANTS:


; Import Constants and tool fonctions
#Include %A_ScriptDir%\Include_URBin_File.ahk


; Need Admin rights except debug.ahk
If not A_IsAdmin and not is_App_Ahk {
	Try  Run %  "*RunAs"  S  A_ScriptFullPath
	ExitApp
}


If is_App_Ahk
	SetWorkingDir %A_ScriptDir%\..  


Global App_Destination_Folder

Global App_Old_Folder
RegRead App_Old_Folder , % App_Reg_Software_App_Name , % "InstallLocation" 

Global App_Old_Uninstall_Filepath :=  App_Old_Folder  "\"  App_Exe_Uninstall_Filename


; Read App_Lang_Default_File (en)
Global LangSystem := Fct_Ini_Read_Vars_Values( App_Lang_Default_File )



IniRead  App_Lang_Ini_Filepath , % App_Config_Ini_Filename , % App_Config_Section_Configuration , % "App_Lang_Ini_Filepath"
Global Lang := Fct_Ini_Read_Vars_Values( App_Lang_Ini_Filepath )

Global Config
If FileExist( App_Config_Ini_Filename )
	Config := Fct_Ini_Read_Vars_Values( App_Config_Ini_Filename )
Else Config := Fct_Ini_Read_Vars_Values( App_System_Config_File )
	Global T_Msg_App_Already_Installed_Ask_Uninstall 
Global T_Msg_Warn_Install_On_USB_Drive 
Global T_Msg_Lang_Welcome
Global T_Button_Uninstall
Global T_Msg_Install_Welcome
Global T_Msg_Installing_App
Global G_Win_System_Dialog_Box_Deleting_Files

Global T_Button_Install_Choose_Folder
Global T_Button_Install_Here
Global T_Button_Install_On_Windows 
Global T_Button_Lang_Open_Tranlation_Folder
Global T_Button_Lang_Select_Another_Tranlation

Global is_USB_Drive_App := Null



; INSTALLATION:


; Wait install successfull or exit
While not Success := Fct_Install_App() 
	Sleep 10 ; Nop


; OK it's finish:


; End of Install
FExitApp() 
ExitApp







;*******************
; SECTION: INSTALL:
;*******************



; Full instalation
Fct_Install_App( ) {
	
	Fct_ToolTip_Close()
	
	; Welcome Install
	If not T_Msg_Install_Welcome 
	{
		Fct_ToolTip_Show( "Prepares for installation ..." )
		If not T_Msg_Install_Welcome := Lang["T_Msg_Install_Welcome"]
			If not T_Msg_Install_Welcome :=  LangSystem["T_Msg_Install_Welcome"] 
				T_Msg_Install_Welcome := LangSystem["T_Msg_Install_Welcome"] 
		
		T_Msg_Install_Welcome := StrReplace( T_Msg_Install_Welcome , "App_Name_Long" , "...\"  App_Name  "\" )
		T_Msg_Install_Welcome := StrReplace( T_Msg_Install_Welcome , "App_Link_SourceForge" 
														,  App_Link_SourceForge ) 
		T_Msg_Install_Welcome := App_Title_Name_Version  2NLines  T_Msg_Install_Welcome
	}
	
	If not T_Button_Install_On_Windows 
		If not T_Button_Install_On_Windows := Lang["T_Button_Install_On_Windows"]
			If not T_Button_Install_On_Windows :=  LangSystem["T_Button_Install_On_Windows"] 
				T_Button_Install_On_Windows :=  LangSystem["T_Button_Install_On_Windows"] 
	
	If not T_Button_Install_Choose_Folder 
		If not T_Button_Install_Choose_Folder := Lang["T_Button_Install_Choose_Folder"]
			If not T_Button_Install_Choose_Folder :=  LangSystem["T_Button_Install_Choose_Folder"] 
				T_Button_Install_Choose_Folder := LangSystem["T_Button_Install_Choose_Folder"]
	
	If not T_Button_Install_Here 
		If not T_Button_Install_Here := Lang["T_Button_Install_Here"]
			If not T_Button_Install_Here :=  LangSystem["T_Button_Install_Here"] 
				T_Button_Install_Here := LangSystem["T_Button_Install_Here"]
	
	; Ask where install it
	;Sleep 400 ; Else window deasepears
	MsgBoxGui( T_Msg_Install_Welcome , T_Button_Install_On_Windows , T_Button_Install_Choose_Folder , T_Button_Cancel ) 
	
	If isCancel()
		FExitApp()  
	
	; Install On Windows ?
	Else If isButton( T_Button_Install_On_Windows ) 
		App_Destination_Folder :=  A_ProgramFiles  "\"  App_Name 
	
	; Install on this folder itself ?
	Else If isButton( T_Button_Install_Here ) 
		App_Destination_Folder := App_Folder 
	
	; User want to choose a folder ?
	Else If isButton( T_Button_Install_Choose_Folder ) 
	{
		
		; Ask User to select a destination folder:
		FolderComputer := "::{20d04fe0-3aea-1069-a2d8-08002b30309d}"
		SelectPrompt := "Select a folder to install this application:"  S S App_Name
		Sleep 400 ; Else window deasepears
		FileSelectFolder  SelectedFolder , % FolderComputer , , % SelectPrompt
		
		; Cancel ?
		Sleep 200
		If not SelectedFolder 
			Return False ; Choose another
		
		; Selected:
		App_Destination_Folder :=  SelectedFolder  "\"  App_Name  ; Add the Folder Name
		App_Destination_Folder := StrReplace( App_Destination_Folder , "\\" , "\" ) ; Fix an error if install on root-drive
	}
	
	If not App_Destination_Folder
		Return False
	
	
	
	; Is instal on USB drive ?
	SplitPath  App_Destination_Folder , , , , , DriveDestination
	WinRecycleBin := DriveDestination  "\"  Win_RecycleBin_Foldername
	is_USB_Drive_App := not FileExist( WinRecycleBin ) ; Check no Win Recycle Bin
	
	isUpdateApp := ( App_Old_Folder = App_Destination_Folder ) 
	
	; Uninstall old ?
	If not is_USB_Drive_App and not isUpdateApp 
		If not Fct_Uninstall_Old_App()
			Return False
	
	; OK Continue Install...
	
	; User must choose lang or exit
	Fct_Lang_Select_File_Welcome() 
	
	If is_USB_Drive_App
	{
		If not T_Msg_Warn_Install_On_USB_Drive {
			If not T_Msg_Warn_Install_On_USB_Drive := Lang["T_Msg_Warn_Install_On_USB_Drive"]
				If not T_Msg_Warn_Install_On_USB_Drive := LangSystem["T_Msg_Warn_Install_On_USB_Drive"]
					T_Msg_Warn_Install_On_USB_Drive := LangSystem["T_Msg_Warn_Install_On_USB_Drive"] 
			
			T_Msg_Warn_Install_On_USB_Drive := StrReplace( T_Msg_Warn_Install_On_USB_Drive , "App_Name_Long" , App_Name )
			T_Msg_Warn_Install_On_USB_Drive :=  App_Title_Name_Version  2NLines  T_Msg_Warn_Install_On_USB_Drive 
		}
		; Say: Warning: USB Drive –> not start automatically
		Sleep 400 ; Else window deasepears
		MsgBoxGui( T_Msg_Warn_Install_On_USB_Drive , T_Button_Big_Yes , T_Button_No )
		
		If isNo()
			Return False ; Choose another
		; Else Yes: continue...
	}
	
	
	; Say installing...
	If not T_Msg_Installing_App := Lang["T_Msg_Installing_App"]
		If not T_Msg_Installing_App :=  LangSystem["T_Msg_Installing_App"] 
			T_Msg_Installing_App := LangSystem["T_Msg_Installing_App"] 
	
	Fct_ToolTip_Show( T_Msg_Installing_App )
	
	; Close main process: 
	Try  Run %  App_Old_Path  "\"  App_Exe_Main_Filename  S S  App_Argument_Exit 
	Sleep 1800
	Try  Process  Close , % App_Exe_Main_Filename ; Force
	
	If not is_USB_Drive_App {
		RegWrite  REG_SZ , % App_Reg_Software_App_Name , % "InstallLocation" , % App_Destination_Folder
		RegWrite  REG_SZ , % App_Reg_Software_App_Name , % "Version" , % App_Version
		RegWrite  REG_SZ , % App_Reg_Software_App_Name , % "Creator" , % "Nico.Godvician"
	}
	
	; Copy files on chosen destination:
	Return Fct_Install_Copy_Files() 
}



Fct_Uninstall_Old_App() {
	
	
	SplitPath App_Old_Folder , , AppOldParentPath
	
	AppUninstallOldFilepath := App_Old_Folder  "\"  App_Exe_Uninstall_Filename
	
	If not FileExist( AppUninstallOldFilepath )
		Return True
	
	; Say to user: Warning already installed Twice –> Need uninstall old
	If not T_Msg_App_Already_Installed_Ask_Uninstall 
	{
		
		If not T_Msg_App_Already_Installed_Ask_Uninstall := Lang["T_Msg_App_Already_Installed_Ask_Uninstall"]
			If not T_Msg_App_Already_Installed_Ask_Uninstall := LangSystem["T_Msg_App_Already_Installed_Ask_Uninstall"]
				T_Msg_App_Already_Installed_Ask_Uninstall := LangSystem["T_Msg_App_Already_Installed_Ask_Uninstall"]
		
		T_Msg_App_Already_Installed_Ask_Uninstall := StrReplace( T_Msg_App_Already_Installed_Ask_Uninstall 
														, "App_Name_Long" ,  App_Name  )
		
		T_Msg_App_Already_Installed_Ask_Uninstall := StrReplace( T_Msg_App_Already_Installed_Ask_Uninstall 
														, "App_Old_Path" ,  App_Old_Folder  "\*"  )
		
		OldSystemConfigFile := App_Old_Folder  "\"  App_System_Config_File
		
		OldConfig := Fct_Ini_Read_Vars_Values( OldSystemConfigFile )
		
		OldAppVersion := StrReplace( OldConfig["App_Version"] , Dot , S Dot )
		
		
		T_Msg_App_Already_Installed_Ask_Uninstall := StrReplace( T_Msg_App_Already_Installed_Ask_Uninstall 
														, "App_Version" ,  OldAppVersion  )
		
		T_Msg_App_Already_Installed_Ask_Uninstall :=  App_Title_Name_Version  2NLines
												. T_Msg_App_Already_Installed_Ask_Uninstall 
	}
	
	If not T_Button_Uninstall
			T_Button_Uninstall := LangSystem["T_Button_Uninstall"]
	
	
	; Warning: Twice must Uninstall old
	Sleep 400 ; Else window deasepears
	MsgBoxGui( T_Msg_App_Already_Installed_Ask_Uninstall , T_Button_Uninstall , T_Button_Cancel )
	
	If isCancel()
		FExitApp()
	
	If isNo()
		Return False ; Choose another 
	
	If isButton( T_Button_Uninstall )
	{
		
		; Uninstall the old App
		OldBatchPathext :=  AppOldParentPath  "\"  App_Batch_Finished_FileName
		
		Try RunWait % AppUninstallOldFilepath  S S  App_Argument_Uninstall_Silent
		
		; Wait totally finished: last batch deleted...
		While FileExist( OldBatchPathext ) { 
			Sleep 1000
			If ( A_Index > 4 ) ; X sec
				Break
		}
		
		;Close Processes: 
		Sleep 250
		Try  
			Process  Close , % App_Exe_Main_Filename ; BUG 
		
		Sleep 250
		Try  
			Process  Close , % "cmd.exe" ; BUG
		
		Sleep 250
		FileDelete % OldBatchPathext
		
	}
	
	RegRead AppOldFolder , % App_Reg_Software_App_Name , % "InstallLocation"
	If FileExist( AppOldFolder )
		Return False
	
	Return True
}







; Welcome: Select Tranlation system file or exit
Fct_Lang_Select_File_Welcome( ) {
	
	If not T_Button_Install_Keep_Lang 
		If not T_Button_Install_Keep_Lang := Lang["T_Button_Install_Keep_Lang"]
			If not T_Button_Install_Keep_Lang :=  LangSystem["T_Button_Install_Keep_Lang"] 
				T_Button_Install_Keep_Lang := LangSystem["T_Button_Install_Keep_Lang"]
	
	If not T_Button_Lang_Select_Another_Tranlation 
		If not T_Button_Lang_Select_Another_Tranlation := Lang["T_Button_Lang_Select_Another_Tranlation"]
			If not T_Button_Lang_Select_Another_Tranlation := LangSystem["T_Button_Lang_Select_Another_Tranlation"] 
				T_Button_Lang_Select_Another_Tranlation := LangSystem["T_Button_Lang_Select_Another_Tranlation"]
	
	; Welcome message
	If not T_Msg_Lang_Welcome
	{
		If not T_Msg_Lang_Welcome
			If not T_Msg_Lang_Welcome := Lang["T_Msg_Lang_Welcome"]
				If not T_Msg_Lang_Welcome :=  LangSystem["T_Msg_Lang_Welcome"] 
					T_Msg_Lang_Welcome := LangSystem["T_Msg_Lang_Welcome"]
		
		T_Msg_Lang_Welcome := StrReplace( T_Msg_Lang_Welcome , "App_Name_Long" , App_Name )
		
		If AppLangLanguage := Lang["App_Lang_Language"]
			T_Msg_Lang_Welcome := StrReplace( T_Msg_Lang_Welcome , "App_Lang_Language" , S S S  Lang["App_Lang_Language"] )
		Else
			T_Msg_Lang_Welcome := StrReplace( T_Msg_Lang_Welcome , "App_Lang_Language" 
									, S S S  "To Choose" )
		
		T_Msg_Lang_Welcome :=  App_Title_Name_Version  2NLines  T_Msg_Lang_Welcome
	}
	
	; Ask to user
	Sleep 400 ; Else window deasepears
	;TODO: little BUG
	If not Lang["App_Lang_Language"]
		MsgBoxGui( T_Msg_Lang_Welcome , T_Button_Big_OK , T_Button_Cancel )
	Else MsgBoxGui( T_Msg_Lang_Welcome , T_Button_Install_Keep_Lang , T_Button_Lang_Select_Another_Tranlation , T_Button_Cancel )
		
	If isCancel()
		FExitApp()
	
	Fct_Lang_Create_New_File_Ini()
	
	If isButton( T_Button_Install_Keep_Lang )
		Return True
	
	;Else is OK or T_Button_Lang_Select_Another_Tranlation
	
	
	; User Must Select a Translation-file
	Fct_Lang_Select_File_And_Read_or_Exit() ; Until user choose or exit
	
	
	Return True
}




; User select a Translation-file then it read it or exit
Fct_Lang_Select_File_And_Read_or_Exit( ) { 
	
	; Build Config-file if needed
	Fct_Config_Create_File_Ini() 
	
	; Buttons needed
	If not T_Button_Lang_Open_Tranlation_Folder
		If not T_Button_Lang_Open_Tranlation_Folder := Lang["T_Button_Lang_Open_Tranlation_Folder"]
			If not T_Button_Lang_Open_Tranlation_Folder := LangSystem["T_Button_Lang_Open_Tranlation_Folder"]				T_Button_Lang_Open_Tranlation_Folder := LangSystem["T_Button_Lang_Open_Tranlation_Folder"]
	
	; Dialog Box to select a Translation File in the translations folder
	
	SelectTitle :=  "Choose your App_Name_Long Translation File:" 
	SelectTitle := StrReplace( SelectTitle , "App_Name_Long" , App_Name )
	SelectExt := App_Name  S "Lang" S  "(*"  Dot  App_Lang_File_Extension  ")"
	LangTargetFolder := App_Folder  "\"  App_Lang_Foldername
	Sleep 400 ; To avoid desepearing
	FileSelectFile  SelectedFile , % FileMustExist := True , % LangTargetFolder , % SelectTitle , % SelectExt
	
	SelectedExtension := SubStr( SelectedFile , 1 - StrLen( App_Lang_File_Extension ) )	
	
	; If User choose no file: Warning !
	If not SelectedFile 
	or ( SelectedExtension != App_Lang_File_Extension )
	or not FileExist( SelectedFile ) 
		Return Fct_Lang_Select_File_Welcome() 
	
	
	; Else User choose a Translation:
	
	; Local ? then remove the \App_Folder\
	If InStr( SelectedFile , App_Folder ) 
		SelectedFile := StrReplace( SelectedFile ,  App_Folder  "\"  , Null ) ; 
	
	
	; If choose « Create New Translation », then open folder and exit	
	If ( SelectedFile = App_Lang_New_Creation_Filepath  ) {
		; Open Folder
		Try  Run  % App_Lang_Foldername 
		FExitApp() 
	}
	
	
	; Else Translation is OK:
	
	
	; Read all Translation file
	Lang := Fct_Ini_Read_Vars_Values( SelectedFile )
	
	; Confirm it's OK
	If not T_Button_Lang_Select_Another_Tranlation
		If not T_Button_Lang_Select_Another_Tranlation := Lang["T_Button_Lang_Select_Another_Tranlation"]
			If not T_Button_Lang_Select_Another_Tranlation := LangSystem["T_Button_Lang_Select_Another_Tranlation"] 
				T_Button_Lang_Select_Another_Tranlation := LangSystem["T_Button_Lang_Select_Another_Tranlation"]
	
	; Read Sytem Section of [WinSystemDialogBoxDeletingFiles]
	IniRead  G_Win_System_Dialog_Box_Deleting_Files 
			, % SelectedFile 
			, % App_Lang_Section_Win_System_Dialog_Box_Deleting_Files 
	
	
	T_Msg_Lang_You_Selected_This_Lang := Lang["T_Msg_Lang_You_Selected_This_Lang"] 
	
	T_Msg_Lang_You_Selected_This_Lang := StrReplace( T_Msg_Lang_You_Selected_This_Lang
											, App_Lang_Section_Win_System_Dialog_Box_Deleting_Files
											, G_Win_System_Dialog_Box_Deleting_Files )
	
	T_Msg_Lang_You_Selected_This_Lang := StrReplace( T_Msg_Lang_You_Selected_This_Lang 
										, "App_Lang_Translator_Name" , Lang["App_Lang_Translator_Name"] )
	
	T_Msg_Lang_You_Selected_This_Lang := StrReplace( T_Msg_Lang_You_Selected_This_Lang 
												, "App_Lang_Language" , Lang["App_Lang_Language"] )
	
	Sleep 400 ; To avoid desepearing
	MsgBoxGui( T_Msg_Lang_You_Selected_This_Lang , T_Button_Big_OK , T_Button_Lang_Select_Another_Tranlation , T_Button_Cancel )
	
	If isCancel()
		FExitApp()
	
	Else If isButton( T_Button_Lang_Select_Another_Tranlation )
		Return Fct_Lang_Select_File_And_Read_or_Exit() ; Choose again
	
	;Else  isOK: Lang confirmed !
	
	App_Lang_Ini_Filepath := SelectedFile
	
	; Write Translation-file in Config.ini
	IniWrite  % App_Lang_Ini_Filepath , % App_Config_Ini_Filename , % App_Config_Section_Configuration , % "App_Lang_Ini_Filepath"
	
	Config := Fct_Ini_Read_Vars_Values( App_Config_Ini_Filename )
	
	Return True 
}






; Create the default Config.ini
Fct_Config_Create_File_Ini( ) {
	
	SourceFilepath := App_Folder  "\"  App_System_Config_File   ; System file
	DestinationFilepath := App_Folder  "\"  App_Config_Ini_Filename  ; New config file
	
	; Copy System Config file to Real Config file
	FileCopy  %  SourceFilepath , % DestinationFilepath , % Overwrite := False	
	
	Return
}


; Build « Create New Translation » file.ini
Fct_Lang_Create_New_File_Ini( ) {
	
	; Create Translation folder (in case of)
	DestinationFolderpath := App_Folder  "\"  App_Lang_Foldername
	If not FileExist( DestinationFolderpath )
		FileCreateDir  %  DestinationFolderpath 	
	
	; Copy System Translation file to Create New Translation file
	SourceFilepath :=  App_Folder  "\"  App_Lang_Default_File
	DestinationFilepath := App_Folder  "\"  App_Lang_Foldername  "\"  App_Lang_New_Creation_Filename
	
	;FileDelete  % DestinationFilepath ; Delete old Config
	FileCopy  % SourceFilepath , % DestinationFilepath , % Overwrite := True
	
	Return
}



; Copy files on chosen destination:
Fct_Install_Copy_Files( ) {	
	
	; Create Destination Folder
	FileCreateDir  % App_Destination_Folder 
	
	; Do not copy on itself !
	If not ( App_Destination_Folder = App_Folder ) 
		FileCopyDir % App_Folder , % App_Destination_Folder , % Overwrite := True 	
	
	; Check if there is a Windows Recycle.Bin: Record to Registry
	If not is_USB_Drive_App ; and not is_App_Ahk
		Return Fct_Install_Create_App_Links() ; Yes: create shortcuts and start
	
	Else ; Not Record to Registry
		Return Fct_Install_Start_App() ; Skip shortcuts
}



; Add App to Windows Registry / Links
Fct_Install_Create_App_Links( ) {	
	
	; Link: AutoStartup with Windows 
	FileDelete % App_Link_Autostartup_Filepath  ; Delete it before
	Sleep 25 ; Wait really deleted ?
	
	FileCreateShortcut  % App_Destination_Folder "\"  App_Exe_Main_Filename  , % App_Link_Autostartup_Filepath , % App_Destination_Folder
	Sleep 25 ; Wait really created ?
	
	
	; Create folder of Links:
	FileCreateDir  % App_AppData_StartMenu_Links_Folder 
	Sleep 25 ; Wait really created ?
	
	
	; Link to App
	FileCreateShortcut  %  App_Destination_Folder "\"  App_Exe_Main_Filename  , %  App_Install_AppData_App_Link , % App_Destination_Folder
	Sleep 25 ; Wait really created ?
	
	
	; Registry path to uninstall app by Windows:
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "DisplayName" , %  App_Name  " – "  App_Version
	RegWrite  REG_SZ , % App_Reg_Software_App_Name , % "DisplayName" , %  App_Name  " – "  App_Version
	
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "InstallLocation" , % App_Destination_Folder
	RegWrite  REG_SZ , % App_Reg_Software_App_Name , % "InstallLocation" , % App_Destination_Folder
	
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "UninstallString" ,%  App_Destination_Folder "\"  App_Exe_Uninstall_Filename
	RegWrite  REG_SZ , % App_Reg_Software_App_Name , % "UninstallString" ,%  App_Destination_Folder "\"  App_Exe_Uninstall_Filename
	
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "UninstallPath" , % App_Destination_Folder 
	
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "DisplayIcon" , % App_Destination_Folder "\"  App_Exe_Uninstall_Filename
	
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "Publisher" , % "SourceForge / Nico.Godvician / Opensource: GNU-GPL-2"
	
	RegWrite  REG_SZ , % App_Reg_Uninstall_Regpath , % "NoModify" , % True
	
	Return Fct_Install_Start_App()
}


; Start App.exe in destination
Fct_Install_Start_App( ) {
	
	;Fct_ToolTip_Close()
	
	If is_USB_Drive_App{
		Try  Run  %  App_Destination_Folder 
		FExitApp()
	}
	
	MsgText :=  App_Title_Name_Version  2NLines  Lang["T_Msg_Install_Success"] 		
	Sleep 400 ; To avoid desepearing
	MsgBoxGui( MsgText )
	
	; Start Main App
	If is_App_Ahk {
		AppTargetAhk := App_Destination_Folder "\"  Config["App_OpenSource_Foldername"]  "\"
					. Config["App_Main_Filename_NoExt"]  Dot  Config["App_Ahk_Full_Extension"]
		Try  Run  %  AppTargetAhk
	}
	Else
		Try  Run  %  App_Destination_Folder "\"  App_Exe_Main_Filename 
	
	FExitApp()
}


FExitApp( ) {
	ExitApp
}




;EOF