﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\..\USB Recycle Bin.exe
Created_Date=1
[VERSION]
Set_Version_Info=1
Company_Name=Nico.Godvician – GNU-GPL-2
File_Description=USB Recycle Bin
File_Version=1.0.2.57
Inc_File_Version=1
Internal_Name=USB Recycle Bin.ahk
Legal_Copyright=GNU-GPL-2 – Nico.Godvician
Original_Filename=USB Recycle Bin.exe
Product_Name=USB Recycle Bin
Product_Version=1.0.2020.1
[ICONS]
Icon_1=%In_Dir%\Ressources\Ico-Trash-Green.ico

* * * Compile_AHK SETTINGS END * * *
*/

;********************************************************************
;***													****
;***	  USB Recycle Bin:  Created by:  Nico.Godvician ( fr )  	****
;***													****
;********************************************************************


; File:			USB Recycle Bin.ahk (Main)		Projet: USB Recycle Bin (Opensource: GNU-GPL)
; File:			SETUP - USB Recycle Bin.ahk
; File:			Uninstall - USB Recycle Bin.ahk



; Language:		AutoHotKey V1 (Opensource) 		https://www.autohotkey.com/
; Help:			AutoHotKey Functions:			https://www.autohotkey.com/docs/AutoHotkey.htm
; Development:		AutoHotkey Studio (Opensource)	https://www.autohotkey.com/boards/viewtopic.php?t=300
; Compilation:		Compiler AHK (Opensource)		https://www.autohotkey.com/boards/viewtopic.php?t=16061




#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

#SingleInstance Force ; Only one of this App at the same time
#Persistent ; Keep App in memory  , don't leave until FExitApp()


DetectHiddenWindows On ; Detect process witout window

FileEncoding  % "UTF-16" ; Encoding all Text File on/from Unicode






;*********************
; SECTION: CONSTANTS:
;*********************


; Import Constants and tool fct
#Include %A_ScriptDir%\Include_URBin_File.ahk



If is_App_Ahk
	SetWorkingDir %A_ScriptDir%\..  



Global App_Filepath := A_ScriptFullPath

Global App_Handle := A_ScriptHWND


; Read System translation (en)
Global LangSystem := Fct_Ini_Read_Vars_Values( App_Lang_Default_File )



;*******************
; SECTION: Globals:
;*******************


Global is_App_Paused_App := False 

Global G_MContext_Separator := "-> Menu_Context_Separator <-"  ; Anything value
Global G_MContext_Item := "-> Menu_Context_Item <-" ; Anything value
Global G_MContext_Submenu := "-> Menu_Context_Submenu <-" ; Anything value

Global is_Del_Shift_Keys_Down_App := False


Global G_ToolTip_Already_Show_Folder

Global G_Ctrl_Z_Action := Null
Global G_Ctrl_Z_TextFilepaths := Null
Global G_Ctrl_Z_Explorer_Folder := Null
Global G_Ctrl_Z_Action_Recover_Deleted_Files := "G_Ctrl_Z_Action_Recover_Deleted_Files" ; Anything value
Global G_Ctrl_Z_Action_Delete_Recovered_Files := "G_Ctrl_Z_Action_Delete_Recovered_Files" ; Anything value


Global G_Time_One_Minute_ms := 60 *1000
Global G_Time_One_Hour_ms := 60 * G_Time_One_Minute_ms 



; End Global
;***********





; Just to remember the begining of code in the fct tree
APP_START( ) {
	Return ; Nop
}




; Arguments := A_Args as array
Argument1 := A_Args[1] 
If ( Argument1 = App_Argument_Exit )
	FExitApp() ; Remove systray icon
;Else If ... ; others arg values...


; Check if is already installed or not ...
RegRead AppRegOldFolderpath , % App_Reg_Uninstall_Regpath , % "InstallLocation"
AppRegOldFilePath :=  AppRegOldFolderpath  "\"  App_Exe_Main_Filename

If ( App_Extension = "exe" )
and not ( AppRegOldFilePath = App_Filepath ) 
and FileExist(  App_Drive  "\"  Win_RecycleBin_Foldername  ) 	
	Fct_ExitApp_Not_Installed()



; Cannot start the same App twice
WinGet AppExistingProcessHandles , List ,  % "ahk_exe" App_Exe_Main_Filename
Loop % AppExistingProcessHandles ; Each current process of this App  (whose this one)
{
	AppExistingProcessHandle := AppExistingProcessHandles%A_Index%
	WinGet AppExistingProcessPathext , ProcessPath , % "ahk_id" AppExistingProcessHandle
	If not ( AppExistingProcessPathext = App_Filepath ) {
		; Is already exist elsewhere: Say Cancel
		MsgText :=  LangSystem["T_Msg_App_Already_Runing"] 
		MsgText := StrReplace( MsgText , "App_Name_Long" , App_Name )
		MsgText := App_Title_Name_Version  2NLines  MsgText
		MsgBoxGui( MsgText )
		FExitApp()
	}
}


; Then in all case: Read Config.ini
Global Config := Fct_Ini_Read_Vars_Values( App_Config_Ini_Filename )

; Get Config vars
Global App_Lang_Ini_Filepath := Config["App_Lang_Ini_Filepath"] 

Global App_RBin_Foldername := Config["App_RBin_Foldername"]

Global App_RBin_Recovery_Ini_Filename := Config["App_RBin_Recovery_Ini_Filename"]



; Convert config vars to integer:
Global App_Delete_Max_Size_Too_Big_File_Mo := Config["App_Delete_Max_Size_Too_Big_File_Mo"]
App_Delete_Max_Size_Too_Big_File_Mo := Round( Fct_Convert_TextToNumber( App_Delete_Max_Size_Too_Big_File_Mo ) )


Global App_RBin_Clean_After_Num_Days := Config["App_RBin_Clean_After_Num_Days"]
App_RBin_Clean_After_Num_Days := Fct_Convert_TextToNumber( App_RBin_Clean_After_Num_Days )


Fct_Convert_TextToNumber( String ) {
	Loop parse , String  ; Parse each character
		If A_LoopField in 0,1,2,3,4,5,6,7,8,9,.,+,-  ; If char is any component of number 
			ToNumber :=  ToNumber  A_LoopField  ; Build number
	Return ToNumber + 0.0 ; Return real number
}


; Convert config vars to boolean
Global App_Ask_For_Open_Folder_Of_Recovered_Files := Config["App_Ask_For_Open_Folder_Of_Recovered_Files"]

Global is_Ask_For_Open_Folder_Of_Recovered_Files := Fct_Convert_TextToBool( App_Ask_For_Open_Folder_Of_Recovered_Files )
Fct_Convert_TextToBool( String ) {
	If ( String = "True" ) ; 'True' or 'true'
		Return Bool := True 
	Else
		Return Bool := False ; For other values: False
}

; Check if is already installed or not ...
RegRead AppRegOldFolderpath , % App_Reg_Software_App_Name , % "InstallLocation"
AppRegOldFilePath :=  AppRegOldFolderpath  "\"  App_Exe_Main_Filename
If not is_App_Ahk
and not ( AppRegOldFilePath = App_Filepath ) 
and FileExist(  App_Drive  "\"  Win_RecycleBin_Foldername  ) 	
	Fct_ExitApp_Not_Installed()


; Check if User has selected a real Translation
If not FileExist( App_Lang_Ini_Filepath ) 
	Fct_ExitApp_Not_Installed()


; Read all Translation file
Global Lang := Fct_Ini_Read_Vars_Values( App_Lang_Ini_Filepath )


; Read App var in Lang-file
Global App_Lang_Language := Lang["App_Lang_Language"]
Global App_Lang_Translator_Name := Lang["App_Lang_Translator_Name"]

Global T_Button_OK := Lang["T_Button_OK"] 
Global T_Button_Big_OK :=  Tab  T_Button_OK  Tab
Global T_Button_Yes := Lang["T_Button_Yes"] 
Global T_Button_Big_Yes :=  Tab  T_Button_Yes  Tab
Global T_Button_No := Lang["T_Button_No"]
Global T_Button_Big_No :=  Tab  T_Button_No  Tab
Global T_Button_Cancel := Lang["T_Button_Cancel"]


Global T_MContext_Show_RBin := Lang["T_MenuContext_Show_RBin"]
Global T_MContext_Recover_Files := Lang["T_MenuContext_Recover_Files"]
Global T_MContext_Empty_RBin := Lang["T_MenuContext_Empty_RBin"]
Global T_MContext_Delete_RBin :=  Lang["T_MenuContext_Delete_RBin"]

; Read Sytem Section ot [WinSystemDialogBoxDeletingFiles]
Global G_Win_System_Dialog_Box_Deleting_Files
IniRead  G_Win_System_Dialog_Box_Deleting_Files 
	, % App_Lang_Ini_Filepath 
	, % App_Lang_Section_Win_System_Dialog_Box_Deleting_Files 


Global T_RBin_File_From_Folder_Source := Lang["T_RBin_File_From_Folder_Source"]

; To Add Source of deleted files into RBin
Global G_RBin_Add_From_Source_Folder_To_File :=  S S S  T_RBin_File_From_Folder_Source 
										. "=["  S  "G_RBin_Add_From_Source_Folder_To_File"  S  "]"

; Match Source of deleted files of RBin
Global G_RBin_Regex_MatchGroup_RBin_File := "\A(.*?)([+]+)?(\s{3}"  T_RBin_File_From_Folder_Source  
												. "=\[\s*.+?\s*\])?(\s*[.][0-9\s\w_]+)?\Z"



; Build tray menu
Fct_MTray_Build() 



;Check or uncheck Start_With_Windows in tray menu
Fct_Autostartup_With_Windows_Update_MTray()




;**********************************************
; Each Timer open new tread and use Goto label
;**********************************************

; Clean old files of RBins 
SetTimer  Go_Clean_All_RBins_Startup_Thread , % RunOnlyOneTime := -10 ; Negativ for only one time at the begining
SetTimer  Go_Clean_All_RBins_Regularely_ThreadTimer , % G_Time_One_Hour_ms *6  ; Regularly each mum hours


; Timer to get handle of explorer
Global G_Current_Explorer_Folder := Null
SetTimer  Go_Update_Current_Explorer_Folder_TimerThread , % ms := 250




;************
; Win Hooks: 
;************


; Windows event when wakeup from standby: reactivate all vars and functions
OnMessage( WM_POWERBROADCAST := 0x218 , "Fct_Wakeup_From_Standby" )


; Register a shell hook each time a new window dialog box is open: Goto this function: Fct_Windows_Open_New_Dialog_Box() :
Global G_Title_Dialog_Box_Open ; Used to receive title of  Dialog Box opened
DllCall( "RegisterShellHookWindow" , "UPtr" , App_Handle ) 
OnMessage( DllCall( "RegisterWindowMessage" , "Str" , "SHELLHOOK" ) , "Fct_Windows_Open_New_Dialog_Box" ) 



Exit ; Exit 1st Thread of Startup: Always runing (Persistent)




; When new Dialog Box is opened :
Fct_Windows_Open_New_Dialog_Box( wParam , lParam ) {
	; When 1st parameter is 1: This Window is a Dialog Box ; (else 0: this is a new Window)?
	If ( isWinDialogBox := wParam == 1 ) 
	{
		; Get Title of Dialog Box
		DialogBoxHandle := lParam
		WinGetTitle  G_Title_Dialog_Box_Open , %  "ahk_id"  DialogBoxHandle
		; Goto immediately without Timer: 
		SetTimer  Go_Dialog_Box_Windows_New_Open_Thread , -1  ; Negative to execute only one time
	}
}



;********************************
; Section New Windows Dialog Box:
;********************************

Go_Dialog_Box_Windows_New_Open_Thread:

; New Dialog Box : But what ? 

If is_App_Paused_App 
	Exit ; Exit this Thread

; Stop if no Title , example: Open with , etc...
If ( G_Title_Dialog_Box_Open == Null ) or ( G_Title_Dialog_Box_Open = A_Space )
	Exit 

; Check this is Dialog Deleting Files
If not InStr( G_Win_System_Dialog_Box_Deleting_Files , G_Title_Dialog_Box_Open )
	Exit ; Not recorded 

; Get current path stored in the title of explorer.exe
;WinGetTitle  CurrentExplorerFolderPath , %  "ahk_id"  G_Explorer_Handle  ; Get from Timer that record the Handle of Explorer

; Check if this drive is removable
CurrentDrive := SubStr( G_Current_Explorer_Folder , 1 , 2 ) 
RemovableDrives := Get_Removable_Drives() 

If not CurrentDrive or not InStr( RemovableDrives , CurrentDrive ) 
	Exit 

; Check if physical Shift+Del keys are down
If GetKeyState( "Shift" ) 
	is_Del_Shift_Keys_Down_App := True 
Else
	is_Del_Shift_Keys_Down_App := False

; Escape to close the Windows Dialog Box of deleting files
Send  {Escape} 

; Wait explorer is active
While not WinActive(  "ahk_class"  Win_Explorer_Class1  ) and not WinActive(  "ahk_class"  Win_Explorer_Class2  ) {
	Sleep 1 ; ms
	If ( A_Index >= 250 ) ; Wait Max
		Exit
}


; Function that delete current selected files in explorer
Fct_Delete_Selected_Files_Ask_All()


Exit ; Close thread



; Function that ask to delete current selected files in explorer:
Fct_Delete_Selected_Files_Ask_All( ) {
	
	; Get all current selected files:
	SelectedFilepaths := Get_Current_Explorer_Selected_Files() 
	If not SelectedFilepaths
		Return
	
	; Get the drive where to delete:
	CurrentDrive := Get_Current_Explorer_Drive()
	
	; RBin of the current Drive
	RBinPath :=  CurrentDrive  "\"  App_RBin_Foldername  
	
	; Get one file
	FirstFilepath := Get_First_Line( SelectedFilepaths )	
	
	
	; 1–> Shift+Del
	If is_Del_Shift_Keys_Down_App { 
		is_Del_Shift_Keys_Down_App := False
		Return Fct_Delete_Selected_Files_Permanently_AskYesNo()
	}
	
	; 2–> is delete RBin ?
	Else If ( SelectedFilepaths = RBinPath ) 
		Return Fct_Delete_RBin_Permanently_AskYesNo()
	
	; 3–> File is already into RBin ? 
	Else If InStr( FirstFilepath , RBinPath ) ; Not Delete the RBin , Ex: Ctrl+A
		Return Fct_Delete_Selected_Files_In_RBin_AskYesNo()
	
	; 4–> Priority to RBin if exist
	Else If FileExist( RBinPath ) and not FileExist(  CurrentDrive  "\"  Win_RecycleBin_Foldername  )
		Return Fct_Delete_Move_Files_Into_RBin()
	
	; 5–> Else If no RBin: Delete permanently 
	Else If not FileExist( RBinPath )
		Return Fct_Delete_Selected_Files_Permanently_AskCreateRBin()
	
	
	Else	; Else: ERROR ??
		MsgBoxGui(  "Error deleting files !" ) 
	
	Fct_ToolTip_Close()
	Return
}


; Delete files into RBin
Fct_Delete_Move_Files_Into_RBin( TextSameFolderFilepaths := "" ) {
	
	; Rename to clarify
	SelectedFilepaths := TextSameFolderFilepaths
	
	; If nothing get current selected files
	If not SelectedFilepaths 
		SelectedFilepaths := Get_Current_Explorer_Selected_Files() 
	
	; If no selected files: Exit
	If not SelectedFilepaths 
		Return
	
	; Get RBin path
	FileDrive := SubStr( SelectedFilepaths , 1 , 2 ) ; Drive is the 2 first chars
	If not FileExist( FileDrive )
		Return 
	
	; is there an RBin ?
	RBinPath :=  FileDrive  "\"  App_RBin_Foldername
	If not FileExist( RBinPath ) 
		Return Fct_Delete_Selected_Files_Permanently_AskCreateRBin() ; Else: delete diles
	
	; Get the system recovery inner file
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename 
	
	; Set Ctrl+Z action to recovering files
	G_Ctrl_Z_Action := G_Ctrl_Z_Action_Recover_Deleted_Files
	FirstFile := Get_First_Line( SelectedFilepaths )
	SplitPath  FirstFile , , FirstFolderpath 
	G_Ctrl_Z_Explorer_Folder := FirstFolderpath
	G_Ctrl_Z_TextFilepaths := Null
	
	ListFileFolderpath := Null
	
	; Split given text-files in array
	ArrayFilepaths := StrSplit( SelectedFilepaths , NLine )
	
	CountFiles := ArrayFilepaths.MaxIndex()
	
	; Show splash screen
	Fct_ToolTip_Show(  Lang["T_Msg_ToolTip_Move_Files_Into_RBin"] , CountFiles ) 
	
	Loop % CountFiles ; For each file:
	{
		; increase Progress bar
		Fct_ToolTip_Show( A_Index )
		
		; For one file
		SourceFilepath := ArrayFilepaths[ A_Index ]
		If not FileExist( SourceFilepath )
			Continue
		
		; Get details of file path 
		SplitPath  SourceFilepath , SourceFilename , SourceFolderpath , FileExt , FilenameNoExt
		
		;Get File Attributes:
		FileGetAttrib  FileAttributes , % SourceFilepath
		isFileFolder := InStr( FileAttributes , "D" )
		isFileSystem := InStr( FileAttributes , "S" )
		
		If ( isFileSystem )
			Continue ;Can not delete System Files
		
		FileSize := Round( Get_SizeKo_Of_Filepath( SourceFilepath ) / 1024 ) ; Ko –> Mo
		
		If ( FileSize > App_Delete_Max_Size_Too_Big_File_Mo ) 
		{
			T_Button_Too_Big_File_Still_Move_RBin := Lang["T_Button_Too_Big_File_Still_Move_RBin"]
			MsgText :=  App_Name  2NLines  Lang["T_Msg_Delete_Permanently_This_Too_Big_File"] 
			MsgText := StrReplace( MsgText , "Too_Big_File_Name" , TooBigFileName := SourceFilepath )
			MsgText := StrReplace( MsgText , "File_Size" , FileSize )
			MsgText := StrReplace( MsgText , "Max_Size_Delete_Too_Big_File" , App_Delete_Max_Size_Too_Big_File_Mo )
			MsgBoxGui( MsgText , T_Button_Yes , T_Button_Too_Big_File_Still_Move_RBin , T_Button_No )
			
			If isYes()
				Fct_Delete_Files_Permanently_NoAsk( SourceFilepath )
			
			Else If isNo()
				Continue
			
			; Else Send to RBin...
			
		}
		
		;G_RBin_Add_From_Source_Folder_To_File :=  S S S  "From=["  S  "G_RBin_Add_From_Source_Folder_To_File"  S  "]"
		
		; Add special 3 Last Foldermames where the File comes from
		
		If not FileExt ; Like most of Folders
			SourceFilename :=  FilenameNoExt  G_RBin_Add_From_Source_Folder_To_File
		
		Else If isFileFolder ; A folder that have an ext
			SourceFilename :=  FilenameNoExt  Dot  FileExt  G_RBin_Add_From_Source_Folder_To_File  
		
		Else ; isFile with ext
			SourceFilename :=  FilenameNoExt  G_RBin_Add_From_Source_Folder_To_File  Dot  FileExt 
		
		; Add parent folders names
		SplitPath  SourceFolderpath , SourceParent1Foldername , SourceParent1Folderpath
		
		If not SourceParent1Foldername
			SourceFoldernames := "USB" ; Root: USB
		
		Else
		{
			; Add Parent folder 1
			SourceFoldernames := Fct_Cut_Too_Long_Line( SourceParent1Foldername , 17 )
			SplitPath  SourceParent1Folderpath , SourceParent2Foldername , SourceParent2Folderpath
			
			; Add Parent folder 2
			If not SourceParent2Foldername
				SourceFoldernames :=  "USB"  " – "  SourceFoldernames
			Else
				SourceFoldernames := Fct_Cut_Too_Long_Line( SourceParent2Foldername , 17 ) 
								. " – "  SourceFoldernames
			
			If SourceParent2Foldername
			{
				; Add Parent folder 3
				SplitPath  SourceParent2Folderpath , SourceParent3Foldername , SourceParent3Folderpath
				If not SourceParent3Foldername
					SourceFoldernames :=  "USB"  " – "  SourceFoldernames
				Else
					SourceFoldernames := Fct_Cut_Too_Long_Line( SourceParent3Foldername , 17 )
									. " – "  SourceFoldernames
				
				; Add Parent folder 3 –> Not used
				If SourceParent3Foldername
				{
					;SplitPath  SourceParent3Folderpath , SourceParent4Foldername , SourceParent4Folderpath
					;If SourceParent4Foldername
					;	SourceFoldernames :=  " ... "  " – "  SourceFoldernames
				}
			}
		}
		
		; Set the source folders in the name of file into RBin destination
		DestinationFilename := StrReplace( SourceFilename , "G_RBin_Add_From_Source_Folder_To_File" , SourceFoldernames )
		
		; Update: FilenameNoExt
		;SplitPath  DestinationFilename , , , , FilenameNoExt 
		
		; Rename file with multiple of "+" while exist into RBin to not overwrite it:
		;G_RBin_Regex_MatchGroup_RBin_File := "\A(.*?)([+]+)?(\s{3}From=\[\s*.+?\s*\])?(\s*[.][0-9\s\w_]+)?\Z"
		While FileExist( RBinPath  "\"  DestinationFilename )
		{
			RegExMatch( DestinationFilename , G_RBin_Regex_MatchGroup_RBin_File , MatchGroup )
			FileName := MatchGroup1
			FileAdded := MatchGroup2 ; Previous '+'
			FileFromFolderName := MatchGroup3
			FileDotExt := MatchGroup4
			If ( A_Index == 1 ) 
				FileAdded := S
			DestinationFilename :=  FileName  FileAdded  "+"  FileFromFolderName  FileDotExt
		}
		;Set final destination into RBin
		DestinationFilepath := RBinPath  "\"  DestinationFilename
		
		; Add destination to Ctrl+Z to recover
		G_Ctrl_Z_TextFilepaths .=  DestinationFilepath  NLine
		
		; Finally: Move the File/Folder !
		If ( isFileFolder ) 
			FileMoveDir  % SourceFilepath , % DestinationFilepath 
		
		Else 
			FileMove  % SourceFilepath , % DestinationFilepath 	
		
		
		; Change creation date by delete date
		FileGetTime  FileDateCreation , % DestinationFilepath , % SaveCreationDate := "C" 
		FileSetTime  % A_Now , % DestinationFilepath , % SetDelateDateToNow := "C" , % OperateOnFolders := True 
		
		; Remove forbidden chars into file.ini
		IniRenamedFilename := Fct_RBin_Replace_Forbidden_Chars_In_Recovery( DestinationFilename )
		
		; Update the recovery system file with file and creation date
		IniWrite  % SourceFilepath , % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files , % IniRenamedFilename
		IniWrite  % FileDateCreation , % IniRecoveryFilepath , % App_RBin_Recovery_Section_DateCreation , % IniRenamedFilename
		
		If not InStr( ListFileFolderpath , SourceFolderpath )
			ListFileFolderpath .= SourceFolderpath NLine
		
		
		Continue ; Move next file...
	}
	
	ArrayFileFolderpath := StrSplit( ListFileFolderpath , NLine )
	Loop % ArrayFileFolderpath.MaxIndex()
		Fct_Refresh_F5_Folder( ArrayFileFolderpath[ A_Index ] )
	Fct_Refresh_F5_Folder( RBinPath )
	
	Fct_ToolTip_Close()
	Return 
}


Get_SizeKo_Of_Filepath( Filepath ) {
	
	FileGetAttrib  FileAttributes , % Filepath
	isFileFolder := InStr( FileAttributes , "D" )
	
	;FileSize := 0
	
	If not isFileFolder
		FileGetSize FileSize , % Filepath , % Ko := "K"
	
	Else  ; isFileFolder:
		Loop Files , %  Filepath  "\*.*" , % "FD"
			FileSize += Get_SizeKo_Of_Filepath( A_LoopFileFullPath )
	
	Sleep 1
	
	Return FileSize
}


; Delete files permanently witout asking to user !
Fct_Delete_Files_Permanently_NoAsk( TextSameDriveFilepaths ) {
	
	; Rename to clarify
	TextFilepaths := TextSameDriveFilepaths
	If not TextFilepaths ; Check if given files are empty
		Return 
	
	; Get RBin path and his Recovery file.ini
	CurrentDrive := SubStr( TextFilepaths , 1 , 2) ; Current drive is the 2 first chars as "E:"
	If not FileExist( CurrentDrive )
		Return
	
	RBinPath :=  CurrentDrive  "\"  App_RBin_Foldername ; RBin of the USB: E:\RBin
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename 
	
	ListFileFolderpath := Null
	
	; Split text files into array
	ArrayFilepaths := StrSplit( TextFilepaths , NLine )
	
	CountFiles := ArrayFilepaths.MaxIndex() 
	
	Fct_ToolTip_Show( Lang["T_Msg_ToolTip_Deleting_Files"] , CountFiles )
	
	Loop % CountFiles ; For each file
	{
		; Increase Splash screen
		Fct_ToolTip_Show( A_Index )
		
		;Get one file
		Filepath := ArrayFilepaths[ A_Index ]
		If not FileExist( Filepath )
			Continue
		
		;Get File Attributes:
		FileGetAttrib  FileAttributes , % Filepath
		isFileFolder := InStr( FileAttributes , "D" )
		isFileSystem := InStr( FileAttributes , "S" )
		
		If ( isFileSystem )
			Continue ; Can not delete System Files
		
		; Get details of file path 
		SplitPath  Filepath , Filename , FileFolderpath
		
		; Finally: Delete this File/Folder
		If ( isFileFolder )
			FileRemoveDir  % Filepath , True 
		Else
			FileDelete  % Filepath 
		
		; If File is into RBin ?
		If ( FileFolderpath = RBinPath ) {
			; Remove from Recovery.ini
			IniRenamedFilename := Fct_RBin_Replace_Forbidden_Chars_In_Recovery( Filename ) ; Get name in Recovery.ini
			IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files , % IniRenamedFilename
			IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_DateCreation , % IniRenamedFilename
		}
		
		If not InStr( ListFileFolderpath , FileFolderpath )
			ListFileFolderpath .= FileFolderpath NLine
		
		Continue ; Next file...
		
	} ; End Loop
	
	ArrayFileFolderpath := StrSplit( ListFileFolderpath , NLine )
	Loop % ArrayFileFolderpath.MaxIndex()
		Fct_Refresh_F5_Folder( ArrayFileFolderpath[ A_Index ] )
	
	
	Fct_ToolTip_Close()
	
	Return 
}



; Delete files permanently but ask user (Shift+Del)
Fct_Delete_Selected_Files_Permanently_AskYesNo( ) {
	
	; Get current selected files
	SelectedFilepaths := Get_Current_Explorer_Selected_Files() 
	If not SelectedFilepaths
		Return 
	
	; Ask user:
	TextFilenames := Get_TextFilenames_From_TextFilepaths( SelectedFilepaths )
	TextFilenames := Get_Compacted_TextFilenames( TextFilenames )
	
	MsgText :=  App_Name 2NLines
			. Lang["T_Msg_Delete_Permanently_Files"]  2NLines  
			. TextFilenames
	
	MsgBoxGui( MsgText , T_Button_Yes , T_Button_No )
	
	If isNo()
		Return ; Cancel deleting
	
	; Function delete files
	Fct_Delete_Files_Permanently_NoAsk( SelectedFilepaths )
	Sleep 50
	Send {F5}
	Return 
}



; Delete files permanently but ask user ; He can create a RBin instead of deleting
Fct_Delete_Selected_Files_Permanently_AskCreateRBin( ) {
	
	; Get current selected files
	SelectedFilepaths := Get_Current_Explorer_Selected_Files() 
	If not SelectedFilepaths
		Return 
	
	;Ask User:
	TextFilenames := Get_TextFilenames_From_TextFilepaths( SelectedFilepaths )
	TextFilenames := Get_Compacted_TextFilenames( TextFilenames )
	
	ButtonCreateRBin := Lang["T_Button_Create_RBin"]
	
	MsgText :=  App_Name 2NLines
			. Lang["T_Msg_Delete_Permanently_Files"]  2NLines  
			. TextFilenames
	
	MsgBoxGui( MsgText , T_Button_Big_Yes , ButtonCreateRBin , T_Button_Cancel ) 
	
	If isButton( ButtonCreateRBin ) {
		; He want to create and move in RBin:
		Fct_RBin_Create_RBin_On_Removable_Drive() ; Create RBin
		Fct_Delete_Move_Files_Into_RBin( SelectedFilepaths ) ; Move files
		Sleep 50
		Send {F5} ; Refresh
		Return
	}
	
	If isCancel()
		Return ; Cancel deleting
	
	;Else YES:
	
	Fct_Delete_Files_Permanently_NoAsk( SelectedFilepaths )
	Sleep 50
	Send {F5}
	Return 
}



; Ask to delete files that are in the RBin
Fct_Delete_Selected_Files_In_RBin_AskYesNo( ) {
	
	; Get selected Files
	SelectedFilepaths := Get_Current_Explorer_Selected_Files() 
	If not SelectedFilepaths
		Return 
	
	; Get RBin path
	FileDrive := SubStr( SelectedFilepaths , 1 , 2 )
	RBinPath :=  FileDrive  "\"  App_RBin_Foldername
	If not FileExist( RBinPath )
		Return 
	
	; Ask User:
	TextFilenames := Get_TextFilenames_From_TextFilepaths( SelectedFilepaths )
	TextFilenames := Get_RBin_TextFiles_Without_Source_Folders( TextFilenames , True )
	TextFilenames := Get_Compacted_TextFilenames( TextFilenames )
	
	MsgText :=  App_Name 2NLines
			. Lang["T_Msg_Delete_Permanently_Files_From_RBin"]  2NLines  
			. TextFilenames
	
	MsgBoxGui( MsgText , T_Button_Yes , T_Button_No )
	
	If isNo()
		Return ; Cancel deleting
	
	; Else: YES:
	Fct_Delete_Files_Permanently_NoAsk( SelectedFilepaths )
	Sleep 50
	Send {F5}
	Return 
}



; Ask to delete RBin and all of his files
Fct_Delete_RBin_Permanently_AskYesNo( ) {
	
	; Get current RBin path
	CurrentDrive := Get_Current_Explorer_Drive()
	RBinPath :=  CurrentDrive  "\"  App_RBin_Foldername
	If not FileExist( RBinPath )
		Return
	
	; Ask User:
	TextFilepaths := Get_RBin_Sorted_By_Deleted_Date_Files( RBinPath )
	TextFilenames := Get_TextFilenames_From_TextFilepaths( TextFilepaths )
	TextFilenames := Get_RBin_TextFiles_Without_Source_Folders( TextFilenames , True )
	TextFilenames := Get_Compacted_TextFilenames( TextFilenames )
	
	MsgText :=  App_Name 2NLines
			. Lang["T_Msg_Delete_Permanently_This_RBin"]  2NLines
			. RBinPath  
			. " \ * "  2NLines 
			. TextFilenames
	
	MsgBoxGui( MsgText , T_Button_Yes , T_Button_No )
	
	If isNo()
		Return ; Cancel deleting
	
	; Else: YES:
	
	; Delete permanently
	Fct_Delete_Files_Permanently_NoAsk( TextFilepaths ) ; Remove files with Progress bar
	FileRemoveDir  % RBinPath , % Recurse := True ; Delete RBin itself
	Sleep 50
	Send {F5}
	Return 
}



; Ask to empty this RBin
Fct_Delete_RBin_To_Empty_AskYesNo( RBinPath := "" ) {
	
	; If no given RBin then get current
	If not RBinPath
		RBinPath :=  Get_Current_Explorer_Drive()  "\"  App_RBin_Foldername
	
	If not FileExist( RBinPath )
		Return 
	
	; Get Files into RBin
	SelectedFilepaths := Get_RBin_Sorted_By_Deleted_Date_Files( RBinPath )
	If not SelectedFilepaths
		Return 
	
	; Ask User:
	TextFiles := Get_TextFilenames_From_TextFilepaths( SelectedFilepaths )
	TextFiles := Get_RBin_TextFiles_Without_Source_Folders( TextFiles , True )
	TextFiles := Get_Compacted_TextFilenames( TextFiles )
	
	MsgText :=  App_Name 2NLines
			. Lang["T_Msg_Ask_ToEmpty_This_RBin"]  NLine 
			. RBinPath  
			. " \ "  ( TextFiles ? "*.*" : Null )  2NLines 
			. TextFiles
	
	MsgBoxGui( MsgText , T_Button_Yes , T_Button_No )
	
	If isNo()
		Return ; Cancel deleting
	
	;Else Yes: Delete files permenently
	Fct_Delete_Files_Permanently_NoAsk( SelectedFilepaths )
	Sleep 50
	Send {F5}
	Return 
}



; Recover imediately these current selected files
Fct_RBin_Recover_Selected_Files( SelectedFilepaths := "" ) { ; Or the Files to Recover
	
	; If no given files then get current files
	If not SelectedFilepaths
		SelectedFilepaths := Get_Current_Explorer_Selected_Files() ; Get Selected Files in Explorer
	
	If not SelectedFilepaths 
		Return 
	
	; Get Drive and RBin and Recovery file
	CurrentDrive := Get_Current_Explorer_Drive()
	RBinPath := CurrentDrive  "\"  App_RBin_Foldername 
	If not FileExist( RBinPath )
		Return 
	
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename ; Recovery File ( System )
	If not FileExist( IniRecoveryFilepath )
		Return 
	
	
	
	Fct_ToolTip_Show( Lang["T_Msg_ToolTip_Recovering_Files"] , CountFiles ) 
	
	isCtrlZRecovering := G_Ctrl_Z_Explorer_Folder and not ( G_Ctrl_Z_Explorer_Folder = RBinPath )
	
	
	; Set Ctrl+Z action to redelete files
	G_Ctrl_Z_Action := G_Ctrl_Z_Action_Delete_Recovered_Files
	G_Ctrl_Z_Explorer_Folder := RBinPath
	G_Ctrl_Z_TextFilepaths := Null
	
	ListFileFolderpath := Null
	
	
	;Split the SelectedFilepaths into Array of each File:
	ArrayFilepaths := StrSplit( SelectedFilepaths , NLine )
	Loop % CountFiles := ArrayFilepaths.MaxIndex()
	{
		; Increased Progress bar
		Fct_ToolTip_Show( A_Index )
		
		; Get one file
		ToRecoverFilepath := ArrayFilepaths[ A_Index ]
		If not FileExist( ToRecoverFilepath )
			Continue
		
		; Get Attributess
		FileGetAttrib  FileAttributes , % ToRecoverFilepath
		isFileFolder := InStr( FileAttributes , "D" )
		isFileSystem := InStr( FileAttributes , "S" )
		If isFileSystem 
			Continue 
		
		; Get details of file path 
		SplitPath  ToRecoverFilepath , ToRecoverFilename , , ToRecoverFileExt , , ToRecoverFromDrive
		
		;Remove forbidden chars in a file.ini
		IniRenamedFilename := Fct_RBin_Replace_Forbidden_Chars_In_Recovery( ToRecoverFilename )
		
		; Get destination from Recovery.ini
		IniRead  DestinationFilepath , % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files , % IniRenamedFilename , %A_Space%
		
		; Is Exist in the Recovery.ini ?
		If not DestinationFilepath 
		{
			; Not Exist in the Recovery.ini: Ask User where to recover it
			
			Fct_ToolTip_Close()
			RealNameFilename := Get_RBin_TextFiles_Without_Source_Folders( ToRecoverFilename )
			
			MsgText :=  App_Name  2NLines 
					. Lang["T_Msg_RBin_Unable_ToRestore_This_Unregistred_File"]  2NLines  
					. ".\"  RealNameFilename
			
			MsgBoxGui( MsgText , T_Button_Yes , T_Button_No )
			
			If isNo() {
				Fct_ToolTip_Show( Lang["T_Msg_ToolTip_Recovering_Files"] , CountFiles )
				Fct_ToolTip_Show( A_Index )
				Continue ; Next file...
			}
			
			SelectRecoverTitle :=  Lang["T_Msg_Recover_Selected_File"]  S ToRecoverFilename
			
			If isFileFolder 
				SelectRecoverExt := Null
			Else
				SelectRecoverExt :=  "File"  Dot  ToRecoverFileExt  "("  "*"  Dot  ToRecoverFileExt  ")"
			
			FolderComputer := "::{20d04fe0-3aea-1069-a2d8-08002b30309d}"
			SelectToRecoverFile :=  ToRecoverFromDrive  "\"  RealNameFilename
			
			Sleep  400 
			If isFileFolder 
				FileSelectFolder DestinationFilepath , % CurrentDrive , , % RealNameFilename
			Else
				FileSelectFile  DestinationFilepath , % SaveButon := "S" 
							, % SelectToRecoverFile , % SelectRecoverTitle , % SelectRecoverExt 
			
			;If User choose no destination:
			If not DestinationFilepath {
				Fct_ToolTip_Show( Lang["T_Msg_ToolTip_Recovering_Files"] , CountFiles )
				Fct_ToolTip_Show( A_Index )
				Continue ; Next file...
			}
			
			If isFileFolder 
				DestinationFilepath := DestinationFilepath  "\"  RealNameFilename
			
			; Else continue to recover it:
			
			Fct_ToolTip_Show( Lang["T_Msg_ToolTip_Recovering_Files"] , CountFiles )
			Fct_ToolTip_Show( A_Index )
			
		}
		
		; Switch drive with current
		DestinationFilepathWithoutDrive := SubStr( DestinationFilepath , 3 )
		DestinationFilepath :=  ToRecoverFromDrive  DestinationFilepathWithoutDrive  ; Path of USB Drive
		
		; Add file to Ctrl+Z
		G_Ctrl_Z_TextFilepaths .=  DestinationFilepath  NLine
		
		; Get destination folder
		SplitPath  DestinationFilepath , , DestinationFoldepath
		
		; Remove folders in name
		DestinationFilename := Get_RBin_TextFiles_Without_Source_Folders( ToRecoverFilename )
		
		; Rename if aleady exist in Destination:
		While FileExist( DestinationFoldepath  "\"  DestinationFilename )
		{
			AddRenaming := "+"
			If ( A_Index == 1 )
				AddRenaming :=  S  AddRenaming
			SplitPath  DestinationFilename , , , DestinationExtension , DestinationFilenameNoExt
			
			If isFileFolder and not DestinationExtension ; 
				DestinationFilename .=  AddRenaming
			
			Else If isFileFolder ; is Folder with ext ?
				DestinationFilename .=  AddRenaming
			
			Else ; Then it's File
				DestinationFilename :=  DestinationFilenameNoExt  AddRenaming  Dot  DestinationExtension
		}
		; Update destination with renamed Filename
		DestinationFilepath :=  DestinationFoldepath  "\"  DestinationFilename
		
		; Finally: Move File into Destination !
		If isFileFolder  
			FileMoveDir  % ToRecoverFilepath , % DestinationFilepath , % Overwrite := True ; Recover Folder
		Else  {
			FileCreateDir % DestinationFoldepath
			FileMove  % ToRecoverFilepath , % DestinationFilepath , % Overwrite := False ; Recover File	
		}
		; Option to open folder of recovered files (false by default)
		If not InStr( RecoveryOpenFolders , DestinationFoldepath ) 
			RecoveryOpenFolders .=  DestinationFoldepath  NLine
		
		; Recover creation date too (from Recovery file)
		IniRead  DateCreationFile , % IniRecoveryFilepath , % App_RBin_Recovery_Section_DateCreation , % IniRenamedFilename
		FileSetTime  % DateCreationFile , % DestinationFilepath , % SetDateCreation := "C" , True ; 	
		
		; Delete from Recovery file.ini
		IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files , % IniRenamedFilename
		IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_DateCreation , % IniRenamedFilename
		
		If not InStr( ListFileFolderpath , DestinationFoldepath )
			ListFileFolderpath .= DestinationFoldepath NLine
		
		Continue ; Next file...
		
	} ; END LOOP
	
	
	
	ArrayFileFolderpath := StrSplit( ListFileFolderpath , NLine )
	Loop % ArrayFileFolderpath.MaxIndex()	
		Fct_Refresh_F5_Folder( ArrayFileFolderpath[ A_Index ] )
	
	Fct_Refresh_F5_Folder( RBinPath )
	
	
	Fct_ToolTip_Close()
	
	; Option to open folder of recovered files
	ArrayRecoveryOpenFolders := StrSplit( RecoveryOpenFolders , NLine )
	If not isCtrlZRecovering and is_Ask_For_Open_Folder_Of_Recovered_Files
		Loop % CountIndex := ArrayRecoveryOpenFolders.MaxIndex() 
		{
			IndexFolderpath := ArrayRecoveryOpenFolders[ A_Index ]
			If not FileExist( IndexFolderpath )
				Continue	
			MsgText := App_Name  2Nlines  Lang["T_Msg_Open_Folder"]  2NLines  IndexFolderpath
			MsgBoxGui( MsgText , T_Button_Yes , T_Button_No )
			If isYes()
				Try  Run  % IndexFolderpath
		}
	
	Return True
}



; Create a Recycle Bin here:
Fct_RBin_Create_RBin_On_Removable_Drive( RBinDrive := "" ) {
	
	; If no given Drive get current
	If not RBinDrive 
		RBinDrive := Get_Current_Explorer_Drive() 
	If not FileExist( RBinDrive )
		Return
	T_Msg_ToolTip_Creating_RBin := Lang["T_Msg_ToolTip_Creating_RBin"]
	; Show creating RBin...
	Fct_ToolTip_Show( T_Msg_ToolTip_Creating_RBin ) 
	
	; Calculate RBin and Recovery path to create
	RBinPath :=  RBinDrive  "\"  App_RBin_Foldername
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename
	
	; Create RBin and set System Attribute
	FileCreateDir  % RBinPath 
	FileSetAttrib  % SystemFile := "+S" , % RBinPath ; Set Attribute: System
	
	; Create Recovery file.ini
	FileAppend  % "["  App_RBin_Recovery_Section_Files  "]"  NLine  NLine  NLine , % IniRecoveryFilepath
	FileAppend  % "["  App_RBin_Recovery_Section_DateCreation  "]"  NLine  NLine  NLine , % IniRecoveryFilepath
	FileSetAttrib  % HiddenSystemFile := "+H+S" , % IniRecoveryFilepath ; Recovery file is: Hidden + System File
	
	Fct_RBin_Show_All_RBins( RBinDrive )
	
	; Wait: Explorer ready:
	While not ( RBinPath = Get_Current_Explorer_Folder() ) {
		Sleep  10
		If ( A_Index * 10 > 1000 ) ; timeout
			Break
	}
	
	If not FileExist( RBinPath) {
		; Echec !
		Fct_ToolTip_Close()
		Return
	}
	
	; Show creating RBin...
	Fct_ToolTip_Show( T_Msg_ToolTip_Creating_RBin ) 
	
	Sleep  1500 ; Wait really ready 
	
	Fct_ToolTip_Show( T_Msg_ToolTip_Creating_RBin ) 
	
	; Set order by deleted date (creation):
	Send  {LAlt}
	Send  v 			; Menu Open Tab: «View»
	Sleep 5 			; Wait ready
	Send  g 			; Open Menu: « Order By »
	Send  {Down 4} 	; Select Field: « By Date »
	Send  {Enter} 		; Valide sorting
	
	Sleep 5 			; Wait ready
	Send  {LAlt}
	Send  v 			; Menu of Tab: «View»
	Send  g 			; Open Menu: « Order By »
	Send  {Down 10} 	; Select Field: « Deacrease »
	Send  {Enter} 		; Valide sorting
	
	Sleep 5 			; Wait ready
	Send  {LAlt}
	Send  h 			; Menu Open Tab: «Home»
	Sleep 5
	Send  {Escape 2} 	; Exit from Alt-Menu
	
	Sleep 200 		; Wait sorting
	
	Fct_ToolTip_Close()
	
	Return
}



; Show this Recycle Bin
Fct_RBin_Show_All_RBins( RBinDrive := "" ) {
	
	; If no given Drive: Show the current RBin
	If not RBinDrive
		RBinDrive := Get_Current_Explorer_Drive()
	
	RBinPath :=  RBinDrive  "\"  App_RBin_Foldername
	
	If FileExist( RBinPath )
		Try  Run  % RBinPath ; If exist show it
	
	Return
}



; Function wakeup from standby: Clean all Drives
Fct_Wakeup_From_Standby( wParam , lParam ) {
	; If Win wParam is Wakeup:
	WakeupParam := wParam 
	If ( WakeupParam == 0 ) or ( WakeupParam == 7 ) or ( WakeupParam == 8 ) 
		SetTimer  Go_Clean_All_RBins_Startup_Thread , % TimeWait := -1 * G_Time_One_Minute_ms 
}



; Threads at Stratup or some times
Go_Clean_All_RBins_Startup_Thread: 
Go_Clean_All_RBins_Regularely_ThreadTimer: 
Fct_RBin_Clean_All_RBins()
Exit



; Clean all RBin of too old files and their Recover file.ini
Fct_RBin_Clean_All_RBins( ) {
	
	; Get Removable Drives
	RemovableDrives := Get_Removable_Drives() 
	
	ArrayRemovableDrives := StrSplit( RemovableDrives , NLine )
	
	Loop % CountDrives := ArrayRemovableDrives.MaxIndex() ; For each Drive
	{
		; Get RBin path
		RBinDrive := ArrayRemovableDrives[ A_Index ]  ; Get one Drive as: "E:"
		RBinPath :=  RBinDrive  "\"  App_RBin_Foldername
		If not FileExist( RBinPath )
			Continue
		
		; OK: Clean this RBin
		Fct_RBin_Clean_Drive_Old_Files( RBinPath )
		Fct_RBin_Clean_Drive_RecoveryIni( RBinPath )
		
		Continue ; Next Drive...
		
	}
	
	Return
}



; Clean given RBin of too old files
Fct_RBin_Clean_Drive_Old_Files( RBinPath ) { 
	
	If not FileExist( RBinPath ) 
		Return 
	
	; Get Recovery filepath to clean its from deleted files
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename 
	
	; For each files in this RBin:
	Loop Files , % AllFilesAndFolders :=  RBinPath  "\*.*"  , % FilesAndDirectories := "FD"
	{
		; Get one file
		Filepath := A_LoopFileLongPath 
		
		; Get Attributes
		FileGetAttrib  FileAttributes , % Filepath	
		isFileSystem := InStr( FileAttributes , "S" )
		isFileFolder := InStr( FileAttributes , "D" )
		If isFileSyste
			Continue ; Do not delete System Files
		
		; Get Revoved Date of file (stored in created)
		FileGetTime  DateFileDeleted , % Filepath , C 
		Date := DateFileDeleted
		Date += App_RBin_Clean_After_Num_Days , Days ; Add num days to check too old files
		FormatTime  DateFileDeletedOldDays , % Date , yyyyMMddHHmmss 
		
		; Get Time Now in seconds
		FormatTime  DateCurrent , % A_Now , yyyyMMddHHmmss 
		
		; Delete file if current date is more thant deleted date + X days
		If ( DateCurrent >= DateFileDeletedOldDays ) 
		{
			;Deleting as File or Folder
			If isFileFolder
				FileRemoveDir  % Filepath , Recurse := True
			Else
				FileDelete  % Filepath
			
			; Remove from Recovery File of RBin
			SplitPath  Filepath , FileName
			IniRecoveryFilename := Fct_RBin_Replace_Forbidden_Chars_In_Recovery( FileName )
			IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files , % IniRecoveryFilename
			IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_DateCreation , % IniRecoveryFilename
			
		}
		
		Continue ; Next File...
		
	} ; End Each file
	
	Return 
}



; Clean Recover-file.ini of the given RBin
Fct_RBin_Clean_Drive_RecoveryIni( RBinPath ) {  
	
	; Get Recovery-file of this RBin
	IniRecoveryFilepath := RBinPath  "\"  App_RBin_Recovery_Ini_Filename 
	If not FileExist( IniRecoveryFilepath ) ; Not Exist this RBin ?
		Return 
	
	; Read all Section: [Recovery_Files]
	IniRead  IniRecoveryLines , % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files
	IniArrayRecoveryLines := StrSplit( IniRecoveryLines , NLine , "`r" )
	
	Loop % CountLines := IniArrayRecoveryLines.MaxIndex() ; For each File/Line
	{
		RecoveryIniLine := IniArrayRecoveryLines[ A_Index ] ; Get one file
		
		; Get File name before '=' of Recovery.ini
		IniRecoveryFilepath := SubStr( RecoveryIniLine , 1 , InStr( RecoveryIniLine , "=" ) - 1 ) 
		
		; Get real name in the RBin from Recovery.ini
		RBinRealFilepath :=  Fct_RBin_Replace_Forbidden_Chars_In_Recovery_To_Real_Name( IniRecoveryFilepath )
		
		; If not exist
		If not FileExist( RBinPath  "\"  RBinRealFilepath )
		{
			; Remove from Recovery.ini (with date)
			IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_Files , % IniRecoveryFilepath
			IniDelete  % IniRecoveryFilepath , % App_RBin_Recovery_Section_DateCreation , % IniRecoveryFilepath
		}
		
		Continue ; Next file...
		
	} ; End each Files
	
	Return 
}




; « Right Click Mouse Button » 
~RButton::   ; Hack right click –> Context menu opens , then modify it:

; Witch active program is it ?
WinGetClass  ClassCurrentWindow , A ; Get class of current Window

; Here we need: explorer.exe
If ( ClassCurrentWindow = Win_Explorer_Class1 ) 
or ( ClassCurrentWindow = Win_Explorer_Class2 ) 
	SetTimer  Go_MContext_Explorer_Thread , -1 ; Only one time

Return ; End of right click




Go_MContext_Explorer_Thread: 
Fct_MContext_Build_RClick_Explorer()
Exit ; Exit the thread



Fct_MContext_Build_RClick_Explorer( ) {
	
	If is_App_Paused_App 
		Return ; Pause: do not change anything
	
	; Get vars to determine witch items to show
	CurrentDrive := Get_Current_Explorer_Drive()
	RBinPath :=  CurrentDrive  "\"  App_RBin_Foldername 
	CurrentFolderpath := Get_Current_Explorer_Folder()
	SelectedFilepaths := Get_Current_Explorer_Selected_Files()
	isIntoRBin := InStr( CurrentFolderpath , RBinPath )
	
	; Array of items to add to the context menu
	ArrayToAddItems := { } 
	
	; Click on File into RBin –> Recover & Empty RBin
	If SelectedFilepaths and ( CurrentFolderpath  =  RBinPath )
	{
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Item( T_MContext_Recover_Files ) ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() )
		ArrayToAddItems.Push( Fct_MContext_Item( T_MContext_Empty_RBin ) ) 	
		ArrayToAddItems.Push( Fct_MContext_Separator() )
	}
	
	; Click on RBin –> Empty & Delete it
	Else If SelectedFilepaths and ( SelectedFilepaths = RBinPath ) 
	{
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Item( T_MContext_Delete_RBin ) ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Item( T_MContext_Empty_RBin ) ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 	
	}
	
	; Click into RBin without Selected Files –> Empty
	Else If not SelectedFilepaths and ( CurrentFolderpath = RBinPath ) 
	{
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Item( T_MContext_Empty_RBin ) ) 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
	}
	
	; Click on File not into RBin –> Show it
	Else If FileExist( RBinPath ) and not isIntoRBin
	{
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
		ArrayToAddItems.Push( Fct_MContext_Item( T_MContext_Show_RBin ) ) ; 
		ArrayToAddItems.Push( Fct_MContext_Separator() ) 
	}
	
	
	
	; Array of Items is empty ?
	CountItems := ArrayToAddItems.Count()
	
	If ( CountItems == 0 ) 
		Return ; No Item to add: nothing change to context menu
	
	InsertItemsAtPosition := 2 ; Just after 'Open' item in menu
	
	TargetProgramClasses := [ Win_Explorer_Class1 , Win_Explorer_Class2 ]
	
	;Function that Add the Items to the Context Menu , and Return the clicked Item , or another "Message"
	ClickedItem := Get_Clicked_Item_From_MContext_Added_Items( TargetProgramClasses 
				, InsertItemsAtPosition 
				, ArrayToAddItems* )
	
	If ( ClickedItem == T_MContext_Recover_Files )
		Fct_RBin_Recover_Selected_Files() ; Recover Selected Files
	
	Else If ( ClickedItem == T_MContext_Empty_RBin ) 
		Fct_Delete_RBin_To_Empty_AskYesNo( RBinPath ) ; Empty the RBin 
	
	Else If ( ClickedItem == T_MContext_Delete_RBin )
		Fct_Delete_Selected_Files_Ask_All() ; Delete the RBin
	
	Else If ( ClickedItem == T_MContext_Show_RBin ) 
		Fct_RBin_Show_All_RBins( CurrentDrive ) ; Show the RBin
	
	Return
}



; MenuContext Tools Functions:
Fct_MContext_Separator( ) {
	Return { Type: G_MContext_Separator }
}

Fct_MContext_Item( Name ) {
	Return { Type: G_MContext_Item , Name: Name }
}

Fct_MContext_Submenu( Name , ArraySubitems ) {
	Return { Type: G_MContext_Submenu , Name: Name , Items: ArraySubitems }
}



; Function that add the items to the context menu , and return the clicked item
; Rewrited from scratch , Published on –> https://www.autohotkey.com/boards/viewtopic.php?f=76&t=38579&p=291014#p290862
Get_Clicked_Item_From_MContext_Added_Items( TargetProgramClasses , InsertItemsAtPosition , ArrayOfItems* ) {
	
	; Get handle of the target program:
	For each , ProgramClass in TargetProgramClasses 
	{
		; Handle of active window:
		If Program_Handle := WinActive(  "ahk_class"  ProgramClass  ) ; Handle return false if class it's not active
			Break ; Program is active , then OK
	} ; Or not if the loop (for each) is finished
	
	; Check we are really in the right active program:
	If not Program_Handle ; False or Handle
		Return "-> Not into the right program <-"	
	
	; Class #32768 is for all standard windows context menu:
	MenuContext_AhkClass := "ahk_class #32768" 
	
	; Wait context menu appears:
	WinWait  % MenuContext_AhkClass ;
	
	; Context menu opened –> Get handle:
	SendMessage  MN_GETHMENU := 0x1E1 , False , False ; Shell Constant: "Menu_GetHandleMenu"
	MenuContext_Handle := ErrorLevel ; Return Handle in ErrorLevel
	
	
	
	;***************************
	; 	Section: Add Items:
	;***************************
	
	; Constants for menus in User32.dll:
	Static MF_SEPARATOR := 0x800
	Static MF_STRING := 0x0
	Static MF_POPUP := 0x10
	Static MF_BYPOSITION := 0x400 
	
	; Add each new item into the context menu:
	For each , ItemToAdd in ArrayToAdd_Items :=  ArrayOfItems
	{
		; Save absolut position of this Item in the menu: 
		ItemToAdd.Position := InsertItemsAtPosition-1 + A_Index-1 ; Zero based
		
		; Add Separator:
		If ( ItemToAdd.Type == G_MContext_Separator ) 
		{
			; Insert Separator: –> https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-InsertMenuA
			DllCall( "User32\InsertMenu"
					,"UPtr" , MenuContext_Handle
					,"UInt" , ItemToAdd.Position ; At the specified position
					,"UInt" , MF_SEPARATOR + MF_BYPOSITION
					,"UPtr" , False
					,"UInt" , False )
		}
		
		; Add Classic Item:
		Else If ( ItemToAdd.Type == G_MContext_Item )
		{
			; Insert text of item: –> https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-InsertMenuA
			DllCall( "User32\InsertMenu" 
					,"UPtr" , MenuContext_Handle
					,"UInt" , ItemToAdd.Position ; At the specified position
					,"UInt" , MF_STRING + MF_BYPOSITION
					,"UPtr" , False 
					,"Str" , ItemToAdd.Name ) ; Insert Value ( text )
		}
		
		; Add Submenu and its Subitems:
		Else If ( ItemToAdd.Type == G_MContext_Submenu )
		{
			AddSubmenu := ItemToAdd ; Renames to clarify
			
			; Create Submenu , and return handle:
			AddSubmenu.Handle := DllCall( "User32\CreatePopupMenu" ) 
			
			;Insert Submenu into the context menu: –> https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-InsertMenuA
			DllCall( "User32\InsertMenu"
					,"UPtr" , MenuContext_Handle
					,"UInt" , AddSubmenu.Position  ; At the specified position
					,"UInt" , MF_STRING + MF_BYPOSITION + MF_POPUP
					,"UPtr" , AddSubmenu.Handle
					,"Str" , AddSubmenu.Name )
			
			; Now add each Item and Separator into this Submenu:
			For each , ItemOfSubmenu in AddSubmenu.Items 
			{
				; AppendMenu –> https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-AppendMenuA
				
				; In case of Separator:
				If ( ItemOfSubmenu == G_MContext_Separator ) 
					DllCall( "User32\AppendMenu"
							,"UPtr" , AddSubmenu.Handle
							,"UInt" , MF_SEPARATOR
							,"UPtr" , False , "UInt" , False )
				
				Else  ; In case of Subintem: insert Value as text:
					DllCall( "User32\AppendMenu"
							,"UPtr" , AddSubmenu.Handle
							,"UInt" , MF_STRING
							,"UPtr" , False
							,"Str" , ItemOfSubmenu )
			}
		}
		Continue ; Continue to add next item...
	}
	; End for each add items
	
	
	
	;***************************
	; 	Section: Wait Click:
	;***************************
	
	Label_MContext_Wait_New_Click: ; When User clicks on Separator: wait new click
	
	; Wait User do a regular or right click:
	While not GetKeyState( "LButton" ) and not GetKeyState( "RButton" ) 
	{
		; Nop
	}
	
	If GetKeyState( "RButton" )
		Return "-> New Right Click <-" ; Then refill the menu
	
	
	
	;***********************************
	; 	Section: Get Clicked Item:
	;***********************************
	
	; Get position of mouse into screen:
	CoordMode  Mouse , Screen
	MouseGetPos  MouseScreenX , MouseScreenY  ; Int vars: 4 octets
	
	; POINT –> https://docs.microsoft.com/fr-fr/previous-versions/dd162805(v=vs.85)
	; Create a generic C++ POINT{x ,y} with a 'ULongLong' –> 'Int64' (bits) 
	; X start at the 1st ULong (right) , and Y start at 2nd ULong (32th bit on left):
	MousePointScreen :=  x := MouseScreenX  |  y := ( MouseScreenY << 32 ) 
	
	; Calculate DPI of special screen: 2K , 4K , 8K , etc...
	ScreenDPIMultiplicator := A_ScreenDPI / 96 ; 96 is the standard 1K DPI screen
	
	; Check if clicked item is into the new added items:
	For each , AddedItemInMenu in ArrayOfAdded_Items := ArrayOfItems 
	{
		; Click on Separator –> Disable:
		If ( AddedItemInMenu.Type == G_MContext_Separator )
		{
			; Get Rectangle of Separator:
			VarSetCapacity( ItemRectangle , 16 , 0 ) ; Create Rectangle of 16 octets: 4 corners of Int (4octets)
			
			; Fill Rectangle: –> https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-GetMenuItemRect
			isFilledRectangle := DLLCall( "User32\GetMenuItemRect"
									,"UPtr" , Program_Handle
									,"UPtr" , MenuContext_Handle
									,"UInt" , AddedItemInMenu.Position ; Absolut position in the context menu
									,"UPtr" , &ItemRectangle )
			; Is clicked on separator ?
			If isFilledRectangle 
			and isPointIntoRectangle := DllCall( "User32\PtInRect" , "UPtr" , &ItemRectangle , "Int64" , MousePointScreen )
				Goto Label_MContext_Wait_New_Click 
		}
		
		; Click on added Item –> Return Value
		Else If ( AddedItemInMenu.Type == G_MContext_Item ) 					
		{
			VarSetCapacity( ItemRectangle , 16 , 0 )
			; https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-GetMenuItemRect
			isFilledRectangle := DLLCall( "User32\GetMenuItemRect"  
									,"UPtr" , Program_Handle
									,"UPtr" , MenuContext_Handle
									,"UInt" , AddedItemInMenu.Position 
									,"UPtr" , &ItemRectangle )
			If isFilledRectangle 
			and isPointIntoRectangle := DllCall( "User32\PtInRect" , "UPtr" , &ItemRectangle , "Int64" , MousePointScreen ) 
				Return AddedItemInMenu.Name
		}
		
		; Click on Submenu –> Check each Subitem:
		Else If ( AddedItemInMenu.Type == G_MContext_Submenu )  				
		{			
			Loop 3 ; 3 times , because sometimes this function does not work 1 or 2 times:
				For each , ItemInSubmenu in ( ItemIsSubmenu := AddedItemInMenu ).Items 
				{
					ItemPositionInMenu := A_Index
					
					; Get Rectangle for Subitem
					VarSetCapacity( ItemRectangle , 16 , 0 ) 
					; https://docs.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-GetMenuItemRect
					isFilledRectangle := DLLCall( "User32\GetMenuItemRect"  
											,"UPtr" , False ; Indicate Submenu , instead of window
											,"UPtr" , ItemIsSubmenu.Handle ; Handle of the Submenu
											,"UInt" , ItemPositionInMenu -1 ; Zero based
											,"UPtr" , &ItemRectangle )
					
					; Get each corner of Rectangle:
					ItemRectangleX1 := NumGet( &ItemRectangle , 0 , "Int" ) ; Int –> 4 octets
					ItemRectangleY1 := NumGet( &ItemRectangle , 4 , "Int" )
					ItemRectangleX2 := NumGet( &ItemRectangle , 8 , "Int" )
					ItemRectangleY2 := NumGet( &ItemRectangle , 12 , "Int" )
					
					; Use DPI multiplicator for exeptional Screen ( 2K , 4K , ... ):
					isMouseInto4Corners :=  ( MouseScreenX >= ItemRectangleX1 *ScreenDPIMultiplicator ) 
									and ( MouseScreenX <= ItemRectangleX2 *ScreenDPIMultiplicator ) 
									and ( MouseScreenY >= ItemRectangleY1 *ScreenDPIMultiplicator ) 
									and ( MouseScreenY <= ItemRectangleY2 *ScreenDPIMultiplicator ) 
					
					; Check if mouse is into this Rectangle: 
					If isFilledRectangle and isMouseInto4Corners
					{
						; Click on Separator ?
						If ( ItemInSubmenu == G_MContext_Separator ) ; Disable Separator
							Goto Label_MContext_Wait_New_Click ; Wait new click
						
						Else ; Standard text Subitem: 
							Return ItemInSubmenu ; Return value of item
					}
					Continue ; Next Subitem
				}
		}
		; End of one item: this is not this item
		Continue ; Then check next item...
	}
	; End: For all the new items , all checked without return
	
	; Then clicked Item is probably on another item of context menu ( like 'Open' ):
	Return "-> Not Clicked AddedItems <-"
}
;End Get clicked item




/*
; « Ctrl+Z » Hook Keys:
;**********************
$^z:: ; Stop: Ctrl+Z –> Do this Function:
;******
Fct_Ctrl_Z_Do_Action()
Return ; End Ctrl+Z



; Reverse last action: delete into /or/ remove from –> RBin
Fct_Ctrl_Z_Do_Action( ) {
	
	;TODO: list of [Ctrl+Z] items ?? Useless ?
	
	; Get current explorer path
	CurrentFolderpath := Get_Current_Explorer_Folder()
	
	isSameRightFolders := ( G_Ctrl_Z_Explorer_Folder = CurrentFolderpath )
	
	If not CurrentFolderpath
		Send  ^z 	 ; It's not for this App then Fire « Ctrl+Z » for others
	
	Else If not isSameRightFolders
		Send ^z	 ; It's not for this App then Fire « Ctrl+Z » for others
	
	Else If not G_Ctrl_Z_TextFilepaths
		Send  ^z 	 ; It's not for this App then Fire « Ctrl+Z » for others
	
	; Action is to recover files ? From same folder ?
	Else If ( G_Ctrl_Z_Action == G_Ctrl_Z_Action_Recover_Deleted_Files ) 
		Fct_RBin_Recover_Selected_Files( G_Ctrl_Z_TextFilepaths ) ; Yes then restore [Ctrl+Z] files
	
	; Action is to remove files in RBin ? From same folder
	Else If ( G_Ctrl_Z_Action == G_Ctrl_Z_Action_Delete_Recovered_Files ) 
		Fct_Delete_Move_Files_Into_RBin( G_Ctrl_Z_TextFilepaths )
	
	Else 
		Send  ^z 	 ; It's not for this App then Fire « Ctrl+Z » for others
	
	Return
}


; Add item if array of items:
Fct_Ctrl_Z_Add_Item( Key_Ctrl_Z_Action , Key_Ctrl_Z_Explorer_Path , Ctrl_Z_Text_Files ) {
	;For: List Ctrl Z
	G_Ctrl_Z_Action := Key_Ctrl_Z_Action
	G_Ctrl_Z_Explorer_Folder := Key_Ctrl_Z_Explorer_Path
	G_Ctrl_Z_TextFilepaths := Ctrl_Z_Text_Files
}


; Delete item if array of items:
Fct_Ctrl_Z_Delete_Item( ) {
	;For: List Ctrl Z
	G_Ctrl_Z_Action := Null
	G_Ctrl_Z_Explorer_Folder := Null
	G_Ctrl_Z_TextFilepaths := Null
}

*/


; Run App and Exit
Fct_Restart_App( ) {
	Try  Run % App_Filepath
	FExitApp() 
}

; Run App as Admin and Exit
Fct_Restart_App_As_Admin( ) {
	Try  Run % "*RunAs "  App_Filepath
	FExitApp() 
}


; Hide the Icon in Systray and Exit
FExitApp( ) {
	Menu Tray , NoIcon ; Hide Icon
	ExitApp
}

Fct_ExitApp_Not_Installed( ) {
	
	If not T_Msg_ExitApp_Not_Installed 
		If not T_Msg_ExitApp_Not_Installed := Lang["T_Msg_ExitApp_Not_Installed"] 
			T_Msg_ExitApp_Not_Installed := LangSystem["T_Msg_ExitApp_Not_Installed"] 
	MsgText :=  App_Name  2NLines  T_Msg_ExitApp_Not_Installed
	MsgBoxGui( MsgText )
	FExitApp() ; And Exit
}


; Return selected files in explorer:
Get_Current_Explorer_Selected_Files( ) { 
	
	Window := Get_Explorer_Window_Object() ; Get object of explorer.exe
	If not Window 
		Return Null
	
	Collection := Window.Document.SelectedItems ; Get only selected files
	
	For FolderFiles in Collection
		ReturnFiles .=  FolderFiles.path  NLine
	
	ReturnFiles := Trim( ReturnFiles , NLine )
	
	Sort  ReturnFiles ; , % CaseIncensitive := "CL"
	
	Return  ReturnFiles
}



; Get RBin files sorted by date of deleted (creation)
Get_RBin_Sorted_By_Deleted_Date_Files( RBinPath ) {
	
	If not FileExist( RBinPath )
		Return Null
	
	; Get all files in RBin by:  "DateDeleted=File"
	Loop Files , % AllFilesAndFolders :=  RBinPath  "\*.*"  , % FilesAndDirectories := "DF" 
		TextDateFilepaths .=  A_LoopFileTimeCreated  "="  A_LoopFileFullPath  NLine
	
	; Sort files by reversed date (most recent in first position)
	Sort  TextDateFilepaths , % NumberByReversedOrder := "NR"
	
	; Clean all dates and keep only filepaths:
	ArrayFilepaths := StrSplit( TextDateFilepaths , NLine )
	Loop % CountFiles := ArrayFilepaths.MaxIndex()
	{
		LineToClean := ArrayFilepaths[ A_Index ] ; Get line
		SeparatorPosition := InStr( LineToClean , "=" )
		Filepath := SubStr( LineToClean , SeparatorPosition +1 ) ; Extract path
		TextSortedFilepaths .=  Filepath  NLine ; Add line with path
	}
	
	; Remove Recovery file.ini
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename
	TextSortedFilepaths := StrReplace( TextSortedFilepaths , IniRecoveryFilepath , Null )
	TextSortedFilepaths := StrReplace( TextSortedFilepaths , 2NLines , NLine )
	
	Return Trim( TextSortedFilepaths , NLine ) ; Trim last NewLine
}



; Return the TextFiles without the folders in the name from the RBin
Get_RBin_TextFiles_Without_Source_Folders( TextFiles , isAddDotSlash := False ) {
	
	If not TextFiles
		Return Null
	
	; Split in Array
	ArrayFiles := StrSplit( TextFiles , NLine )
	
	;For each file
	Loop % CountFiles := ArrayFiles.MaxIndex() 
	{
		; Get file
		File := ArrayFiles[ A_Index ]
		
		; Path ? Or Filename ?
		If FileExist( File )
			SplitPath  File , Filename , FileFolderpath
		Else 
			FileName := File ; Filename
		
		; Rebuild the filename:
		;G_RBin_Regex_MatchGroup_RBin_File := "\A(.*?)([+]+)?(\s{3}From=\[\s*.+?\s*\])?(\s*[.][0-9\s\w_]+)?\Z"
		RegExMatch( Filename , G_RBin_Regex_MatchGroup_RBin_File , MatchGroup )
		FilenameMatched := MatchGroup1
		FilePlusAdded := MatchGroup2
		FileFromFolderpath := MatchGroup3 ; Not returned
		FileDotExt := MatchGroup4
		
		FileRenamed :=  FilenameMatched  FilePlusAdded  FileDotExt
		
		If FileFolderpath ; If path: rebuild it
			FileRenamed := FileFolderpath "\" FileRenamed
		
		; Add File
		ReturnTextFiles .= ( isAddDotSlash ? ".\"  : Null )  FileRenamed  NLine
		
		FileFolderpath := Null
		
		Continue ; Next file...
	}
	
	; Remove Recovery file.ini
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename
	ReturnTextFiles := StrReplace( ReturnTextFiles , IniRecoveryFilepath , Null )
	ReturnTextFiles := StrReplace( ReturnTextFiles , 2NLines , NLine )
	
	Return Trim( ReturnTextFiles , NLine ) ; Trim newline
}



; Return Filenames from Filepaths
Get_TextFilenames_From_TextFilepaths( TextFilepaths ) {
	
	If not TextFilepaths 
		Return Null
	
	; Split in Array
	ArrayFilepaths := StrSplit( TextFilepaths , NLine ) 
	
	; For each file
	Loop % CountFiles := ArrayFilepaths.MaxIndex() 
	{
		; Get the Delete File Name of next File to show to User:
		Filepath := ArrayFilepaths[ A_Index ]
		SplitPath  Filepath , Filename
		TextFilenames .= Filename NLine
	}
	
	; Remove Recovery file.ini
	IniRecoveryFilepath :=  RBinPath  "\"  App_RBin_Recovery_Ini_Filename
	TextFilenames := StrReplace( TextFilenames , IniRecoveryFilepath , Null )
	TextFilenames := StrReplace( TextFilenames , 2NLines , NLine )
	
	Return Trim( TextFilenames , NLine ) ; Trim newline
}



; Return limited list of files
Get_Compacted_TextFilenames( TextFilenames , MaxFiles := 12 ) {
	
	If not TextFilenames
		Return Null
	
	; Split in Array
	ArrayFilenames := StrSplit( TextFilenames , NLine )
	
	CountFiles := ArrayFilenames.MaxIndex()
	If ( CountFiles <= MaxFiles ) ; If not need to cut: Return right files
		Return TextFilenames
	
	; For each file until max
	Loop % MaxFiles
		ReturnFilenames .=  ArrayFilenames[ A_Index ]  NLine
	
	ReturnFilenames .=   ". . ."
	
	Return Trim( ReturnFilenames , NLine )
}




Fct_RBin_Replace_Forbidden_Chars_In_Recovery( FilenameToIni ) {
	
	FilenameToIni := StrReplace( FilenameToIni , "=" , "``~~~" )
	FilenameToIni := StrReplace( FilenameToIni , ";" , "``,,," )
	FilenameToIni := StrReplace( FilenameToIni , "[" , "``(((" )
	FilenameToIni := StrReplace( FilenameToIni , "]" , "``)))" )
	
	Return FilenameToIni
}

Fct_RBin_Replace_Forbidden_Chars_In_Recovery_To_Real_Name( IniToRealFilename ) {
	
	IniToRealFilename := StrReplace( IniToRealFilename , "``~~~" , "=" )
	IniToRealFilename := StrReplace( IniToRealFilename , "``,,," , ";" )
	IniToRealFilename := StrReplace( IniToRealFilename , "``(((" , "[" )
	IniToRealFilename := StrReplace( IniToRealFilename , "``)))" , "]" )
	
	Return IniToRealFilename
}



; Return 1st line of text
Get_First_Line( TextToLine ) {
	Return StrSplit( TextToLine , NLine , "`r" )[1] ; To Array , get first line
}



; Return Line cuted at the given position
Fct_Cut_Too_Long_Line( LineToCut , NumChars , isAddDots := False ) {
	If ( StrLen( LineToCut ) <= Abs( NumChars ) ) ; Calcul if needed or not
		Return  LineToCut
	Else If ( NumChars > 0 )
		Return  SubStr( LineToCut , 1 , NumChars )  ( isAddDots ?  "..." : Null )
	Else If ( NumChars < 0 )
		Return  ( isAddDots ?  "..." : Null )  SubStr( LineToCut , NumChars )
	Return LineToCut
}



; Save quicly the handle of explorer into G_Explorer_Handle
Go_Update_Current_Explorer_Folder_TimerThread:
G_Current_Explorer_Folder := Get_Current_Explorer_Folder()
Exit ; Exit thread




FURBinAbout() {
	App_Description_2Line := Lang["App_Description_2Line"] 
	MsgText =
(
%App_Title_Name_Version%

%App_Description_2Line%

Language:		%App_Lang_Language%     
Translated by:	%App_Lang_Translator_Name%

Project published on the website: 
Usb-Recycle-Bin.SourceForge.io

Created by  Nico.Godvician  
OpenSource Licence:  GNU-GPL-2  

Powered by:	AutoHotkey		(opensource)
Developped with:	AutoHotKey Studio		(opensource)
Compiled with:	AutoHotKey Compiler AHK	(opensource)

Installed on:  %App_Folder%
)
	MsgBoxGui( MsgText )
}



is_Into_USB_Drive( ) {
	Return InStr( Get_Removable_Drives() , Get_Current_Explorer_Drive() )
}


; Get Drives without Windows Recycle.Bin
Get_Removable_Drives( ) {
	
	AllDrives := "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	
	Loop % StrLen( AllDrives ) ; Each Drive-letter
	{
		IndexDrive := SubStr( AllDrives , A_Index , 1 )  ":" 
		
		WinRecycleBinPath :=  IndexDrive  "\"  Win_RecycleBin_Foldername 
		
		If FileExist( IndexDrive ) ; Check if Drive realy exist
		and not FileExist( WinRecycleBinPath ) ; Check if this Drive has no Win-Recycle-Bin
			RemovableDrives .=  IndexDrive  NLine 
		
		Continue
		
	}
	
	Return RemovableDrives ; 
}




;********************
; SECTION: MenuTray:
;********************


; Build tray menu:
Fct_MTray_Build( ) {
	
	; Disable standard Ahk Systray Menu
	Menu  Tray , NoStandard
	Menu  Tray , NoMainWindow
	
	Menu  Tray , Add ; Separator
	Menu  Tray , Add , % Lang["T_MenuTray_About_App"] , GoMenuTrayAbout
	
	Menu  Tray , Add 
	Menu  Tray , Add , % Lang["T_MenuTray_Help_App"] , Go_MTray_Help
	
	Menu  Tray , Add 
	Menu  Tray , Add , % Lang["T_MenuTray_Open_Folder_App"] , Go_MTray_Open_App_Folder
	
	Menu  Tray , Add 
	Menu  Tray , Add , % Lang["T_MenuTray_Start_With_Windows"] , Go_MTray_Startup_With_Windows_Toggle
	
	Menu  Tray , Add 
	Menu  Tray , Add , % Lang["T_MenuTray_Pause_App"] , Go_MTray_Toggle_Pause_App
	
	Menu , Tray , Add 
	Menu , Tray , Add , % Lang["T_MenuTray_Restart_App"] , Go_MTray_Restart_App 
	
	Menu  Tray , Add 
	Menu  Tray , Add 
	Menu  Tray , Add , % Lang["T_MenuTray_Exit_App"] , Go_MTray_ExitApp
	Menu  Tray , Add 
	
	; On one left click on tray Icon: Show Window About Appli
	Menu  Tray , Click , 1
	Menu  Tray , Default , % Lang["T_MenuTray_About_App"]
	
	; ToolTip on Systray icon:
	T_MTray_ToolTip_About :=  App_Title_Name_Version  "`r"  NLine
						. Lang["T_MenuTray_ToolTip_About"]  "`r"  NLine
						. App_Folder 
	
	Menu  Tray , Tip , % T_MTray_ToolTip_About
	
	Return
}



Fct_MTray_Disable_Item( TrayMenuToDisable ) {
	Menu  Tray , Disable , % TrayMenuToDisable
}


Fct_MTray_Check_Item( TrayMenuToCheck ) {
	Menu  Tray , Check , % TrayMenuToCheck
}


Fct_MTray_Uncheck_Item( TrayMenuToUncheck ) {
	Menu  Tray , Uncheck , % TrayMenuToUncheck
}



Go_MTray_Help:
Fct_Show_Help()
Return


Fct_Show_Help( ) {
	; Try open with notepad
	Try  Run %    App_Folder  "\"  App_Lang_Foldername  "\"  Lang["App_Lang_Help_File"] 
	Catch {
		; Else show in Text Box
		FileRead  MsgText , % Lang["App_Lang_Help_File"]
		MsgBoxGui( MsgText )
	}
}



Go_MTray_Startup_With_Windows_Toggle:
Fct_Autostartup_With_Windows_Toggle()
Return 




Fct_Autostartup_With_Windows_Toggle( ) {
	
	; Create the Autostart in Startup
	If not FileExist( App_Link_Autostartup_Filepath ) ; Shortcut to Start with Windows
		FileCreateShortcut  %  App_Folder  "\"  App_Exe_Main_Filename , % App_Link_Autostartup_Filepath , % App_Folder 
	
	Else	; Delete the Autostart in Startup
		FileDelete  % App_Link_Autostartup_Filepath 
	
	Fct_Autostartup_With_Windows_Update_MTray()
}




Fct_Autostartup_With_Windows_Update_MTray( ) {
	
	If not T_MTray_Start_With_Windows
		T_MTray_Start_With_Windows := Lang["T_MenuTray_Start_With_Windows"]
	
	If is_App_Ahk
		Fct_MTray_Disable_Item( T_MTray_Start_With_Windows )
	
	Else If FileExist( App_Link_Autostartup_Filepath ) ; Shortcut to Start with Windows
		Fct_MTray_Check_Item( T_MTray_Start_With_Windows )
	
	Else If not FileExist( App_Link_Autostartup_Filepath )
		Fct_MTray_Uncheck_Item( T_MTray_Start_With_Windows )
	
	Return
}



GoMenuTrayAbout: 
FURBinAbout()
Return 





; Open folder of application
Go_MTray_Open_App_Folder: 
Try  Run  % App_Folder 
Return



Go_MTray_Toggle_Pause_App: 
Fct_Pause_App_Toggle()
Return 


Fct_Pause_App_Toggle( ) {
	is_App_Paused_App := not is_App_Paused_App 
	If is_App_Paused_App
		Menu  Tray , Check , % A_ThisMenuItem 
	Else
		Menu  Tray , Uncheck , % A_ThisMenuItem 
}





Go_MTray_Restart_App:
Fct_Restart_App()
Return





Go_MTray_ExitApp:
FExitApp()
Return







;EOF
