﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\..\Uninstall - USB Recycle Bin.exe
Created_Date=1
Execution_Level=4
[VERSION]
Set_Version_Info=1
Company_Name=Nico.Godvician – GNU-GPL-2
File_Description=Uninstall - USB Recycle Bin
File_Version=1.0.2.9
Inc_File_Version=1
Internal_Name=Uninstall - USB Recycle Bin.ahk
Legal_Copyright=GNU-GPL-2 – Nico.Godvician
Original_Filename=Uninstall - USB Recycle Bin.exe
Product_Name=USB Recycle Bin
Product_Version=1.0.2020.1
[ICONS]
Icon_1=%In_Dir%\Ressources\Ico-Trash-Red.ico

* * * Compile_AHK SETTINGS END * * *
*/

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.




;*****************************
;
; Uninstall USB Recycle Bin
;
;*****************************



; RUN AS ADMINISTRATOR





;*********************
; SECTION: CONSTANTS:
;*********************


; Import Constants and tool fct
#Include %A_ScriptDir%\Include_URBin_File.ahk


; Need Admin rights
If not A_IsAdmin and not is_App_Ahk {
	Try  Run %  "*RunAs"  S  A_ScriptFullPath
	ExitApp
}



Argument1 := A_Args[1] 

; Arguments := A_Args as array
Global Arg_Silent := False
If ( Argument1 = App_Argument_Uninstall_Silent )
	Arg_Silent := True 

;Else If ... ; others arg values...





; Get App vars 
Global App_Uninstall_Filepath := A_ScriptFullPath
Global App_Folder , App_Foldername , App_Parent_Folder 
SplitPath App_Uninstall_Filepath , , App_Folder 
SplitPath App_Folder , App_Foldername , App_Parent_Folder 


; Then in all case: Read Config.ini
Global Config := Fct_Ini_Read_Vars_Values( App_Config_Ini_Filename )

; Get Config vars
Global App_Lang_Ini_Filepath := Config["App_Lang_Ini_Filepath"] 

; Read all Translation file
Global Lang := Fct_Ini_Read_Vars_Values( App_Lang_Ini_Filepath )

; Read Setup translation (en)
Global LangSystem := Fct_Ini_Read_Vars_Values( App_Lang_Default_File )


If not T_Msg_Uninstalling_App := Lang["T_Msg_Uninstalling_App"]
	If not T_Msg_Uninstalling_App :=  LangSystem["T_Msg_Uninstalling_App"] 
		T_Msg_Uninstalling_App := LangSystem["T_Msg_Uninstalling_App"] 

Fct_ToolTip_Show( T_Msg_Uninstalling_App ) 



;*******************
; Section Confimm: 
;*******************



; Cannot uninstall if not regisered

; Check if is already installed or not ...
RegRead AppRegFolderpath , % App_Reg_Software_App_Name , % "InstallLocation"
AppRegFilepath :=  AppRegFolderpath  "\"  App_Exe_Uninstall_Filename
If not ( App_Uninstall_Filepath = AppRegFilepath )
{
	; Not registered: Cancel Uninstall
	If not MsgText := Lang["T_Msg_ExitApp_Uninstall_Not_Registered"] 
		MsgText :=  LangSystem["T_Msg_ExitApp_Uninstall_Not_Registered"] 
	MsgText := StrReplace( MsgText , "App_Full_Path" , App_Folder  "\"  )
	MsgText :=  App_Title_Name_Version  2NLines  MsgText  NLine
	; Say: Impossible
	MsgBoxGui( MsgText )
	ExitApp
}


;Confirm Uninstall ?
If not Arg_Silent {
	
	If not MsgText  := Lang["T_Msg_Ask_To_Confirm_Uninstall"]
		MsgText :=  LangSystem["T_Msg_Ask_To_Confirm_Uninstall"]
	
	MsgText := StrReplace( MsgText , "App_Name_Long" ,  App_Name  )
	MsgText := StrReplace( MsgText , "App_Full_Path" ,  App_Folder  "\"  )
	MsgText :=  App_Title_Name_Version  2NLines  MsgText 
	
	;SoundPlay *48 ; Beep Windows
	
	MsgBoxGui( MsgText , T_Button_No , T_Button_Big_Yes  )
	
	If isNo()
		ExitApp
	
	; Else YES: 
	Fct_ToolTip_Show( T_Msg_Uninstalling_App ) 
	
}
Else {
	Fct_ToolTip_Show( T_Msg_Uninstalling_App ) 
	Sleep 1000
}




;********************
; SECTION UNINSTALL:
;********************




;Close Process: 
Try  Run %  App_Folder  "\"  App_Exe_Main_Filename  S S  App_Argument_Exit 
Sleep 1200
Try  Process  Close , % App_Exe_Main_Filename ; Force


;Delete Registry Uninstall:
RegDelete % App_Reg_Uninstall_Regpath
RegDelete % App_Reg_Software_App_Name



;Remove Folder of: All Start Menu Shortcuts.lnk
FileRemoveDir % App_AppData_Links_Folder , % Recurse := True 

;Remove Shortcut of: Startup with Windows
FileDelete % App_Link_Autostartup_Filepath



; Erase Entire Folder:
;**********************


App_Batch_Erase_FileName := "#WARNING_ERASE_Folder_USB_Recycle_Bin_Temp.bat"
App_Batch_Finished_FileName := "$OK_Uninstalled_USB_Recycle_Bin_Temp.bat"



; Create Eraze.bat 
BatchFileContentEraze =
(
@Echo OFF

REM Unicode:
chcp 1252 > Nul

REM Goto CD = this Script
CD /d "`%~dp0"

REM Wait 1s
Ping 127.0.0.1 -n 1 > Nul

REM Remove Folder: 
Erase /F/Q/S "%App_Foldername%" > Nul

REM Wait 1s
Ping 127.0.0.1 -n 1 > Nul

RMDir /Q/S "%App_Foldername%" > Nul

REM Wait 1s
Ping 127.0.0.1 -n 1 > Nul

REM Start OK.bat
Start  "%A_ScriptName%"  /D  "%App_Parent_Folder%"  "%App_Batch_Finished_FileName%"  > Nul

REM Delete itself:
DEL "`%~f0"  > Nul
)

BatchEraseFilepath :=  App_Parent_Folder  "\"  App_Batch_Erase_FileName

FileDelete % BatchEraseFilepath
FileAppend % BatchFileContentEraze , % BatchEraseFilepath

While not FileExist( BatchEraseFilepath ) ; Wait for Exist
	Sleep 10


; Read Message to say user when it's finish
If not T_Msg_DOS_Uninstall_Successfull := Lang["T_Msg_DOS_Uninstall_Successfull"]
	T_Msg_DOS_Uninstall_Successfull := LangSystem["T_Msg_DOS_Uninstall_Successfull"] 
T_Msg_DOS_Uninstall_Successfull := StrReplace( T_Msg_DOS_Uninstall_Successfull , "App_Name_Long" , App_Name )


If not T_Msg_DOS_Uninstall_Press_Key := Lang["T_Msg_DOS_Uninstall_Press_Key"]
	T_Msg_DOS_Uninstall_Press_Key :=  LangSystem["T_Msg_DOS_Uninstall_Press_Key"] 

If not T_Msg_DOS_Uninstall_Close_DOS := Lang["T_Msg_DOS_Uninstall_Close_DOS"]
	T_Msg_DOS_Uninstall_Close_DOS := LangSystem["T_Msg_DOS_Uninstall_Close_DOS"] 




; Create OK.bat
BatchFileContentFinished =
(
@Echo OFF

REM Unicode:
chcp 1252 > Nul

REM Goto this script
CD /d "`%~dp0" > Nul

Echo.
Echo.
Echo.
Echo.
Echo.
Echo             %App_Title_Name_Version%
Echo.
Echo.
Echo.
Echo.
Echo             %T_Msg_DOS_Uninstall_Successfull%
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo             %T_Msg_DOS_Uninstall_Press_Key%
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.

REM Wait User Click Close:
Pause > Nul

REM Clear Screen:
CLS 

Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo                          %T_Msg_DOS_Uninstall_Close_DOS% 
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.
Echo.

REM Delete itself:
DEL "`%~f0"
)

BatchOKFinishedFilepat :=  App_Parent_Folder  "\"  App_Batch_Finished_FileName

FileDelete % BatchOKFinishedFilepat
FileAppend % BatchFileContentFinished , % BatchOKFinishedFilepat
While not FileExist( BatchOKFinishedFilepat ) ; Wait for Exist
	Sleep 10


; Execute Erasing.bat that call OK.bat
Run % BatchEraseFilepath , % App_Parent_Folder , Minimize ; Run Batch deletor Files...


; Immediately Exit
ExitApp





;EOF